/********************************************************************/
/*	EASYFSEL.H														*/
/*																	*/
/*	Include-Datei zu EASYFSEL.C.									*/
/*																	*/
/*	Revision: 6														*/
/*	Datum   : 15.06.1992											*/
/*  Autor   : Andreas Papula										*/
/*																	*/
/*	Copyright 1992 by MAXON Computer GmbH.							*/
/*  Erweiterungen von Dimitri Junker								*/
/********************************************************************/

#include <portab.h>
#include <stdio.h>
#include <tos.h>


typedef char	BOOLEAN;


#define TRUE 1
#define FALSE 0

/* Erweitertes DTA fr lange Filenamen	*/
typedef struct
{
    char            d_reserved[21];
    unsigned char   d_attrib;
    unsigned int    d_time;
    unsigned int    d_date;
    unsigned long   d_length;
    int				d_max_pfad;		/* Max Lnge des Pfades	*/
    int				d_max_name;		/* Max Lnge des Namen	*/
    char            *d_fname;
	char			*d_pfad;
	char			d_maske[64];
	long			d_handle;
	int				d_flags;		/* fsfirst etc verwenden s.u.*/
	int				d_sattr;		/* Die Fsfirst Attribut		*/
} DTAX;

#define DTF_DO	1
#define DTF_FX	2
#define DTF_DX	4
/* DTF_DO gibt an ob Dopendir, Dreaddir und Dclosedir vorhanden sind	*/
/* DTF_FX gibt an ob Fxattr vorhanden ist	*/
/* DTF_DX gibt an ob Dxreaddir vorhanden ist	*/

extern DTAX My_dta;

/*------------------------------------------------------------------*/
/*	Funktionsprototypen.																						*/
/*------------------------------------------------------------------*/

BOOLEAN easy_fsel(BYTE *pfad, BYTE *dateiname, BYTE *text);
VOID build_filename(BYTE *dest, BYTE *pfad, BYTE *dateiname);
BYTE *get_akt_path(BYTE *path);
BOOLEAN get_cookie(long cookie_name, LONG *cookie_value);
BOOLEAN exist(const BYTE *dateiname);
long lof(FILE *stream);
int fsfirst( const char *filename, int attr );
long Dxreaddir(int len,long dirhandle, char *buf,XATTR *xatttr,long *xret);
void trenn_pfad(char *pfad,char *name,const char *file);
int fsnext(void);

/*----------------------- Ende der Datei. --------------------------*/