/*			Patch_PD V1.08
		(c) 1997,98 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen	*/
#define NEWTOS

#define PRGNAME "PATCH_PD"
#define PRGVERS "1.08"



/* -------------------------------------------------------------------- */
/*		IncludesF														*/
/* -------------------------------------------------------------------- */
 
#include "easyfsel.h"
#include "patch.h"
#include "patchrsc.h"

#include <vdi.h>
#include <aes.h>
#include <string.h>
#include <stdlib.h>


/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */

#define MAX_SYM 400
#define MAX_REL	500
#define MAX_NR	200

#define MAGIC 0x4EFA001CL

/* Originalroutinen aus PD	*/
#define		DRAW_MENU		0
#define		SHOW_CURS		1
#define		HIDE_CURS		2
#define		RESET			3
#define		RESET_A			4
#define		MALLOC_H		5
#define		MFREEL1			6
#define		BOMB28			7
#define		BOMB33			45
#define		BOMBEN			8
#define		RESMYEXC		9
#define		SETMYEXC		10
#define		BOMB4			11
#define		TRACE			12
#define		NOPRIV			13
#define		LINEA			14
#define		AESVDI			15
#define		TOS1			16
#define		MEMCPYX			17
#define		ESC_H_ETC		18
#define		RESGDT			19
#define		MFREEAS			20
#define		GEMDOS2			21
#define		SETGDT			22
#define		GEMDOS2A		23
#define		ETVTRM			24
#define		FCLOSE			25
#define		FREAD			47
#define		SETEXC			26
#define		MXALLOC			27
#define		MSHRINK			28
#define		MFREE			29
#define		MALLOC			30
#define		SETSCREEN		31
#define		PHYSBASE		32
#define		LOGBASE			33
#define		GRAF_HANDLE		34
#define		FORM_ALERT		35
#define		V_SHOW_C		36
#define		V_OPNVWK		37
#define		V_HIDE_C		38
#define		V_CLSVWK		39
#define		VRO_CPYFM		40
#define		VQ_MOUSE		41
#define		VQ_EXTND		42
#define		SETHCV			43
#define		RESHCV			44
#define		VIEW_F			46
#define		FPUINIT			48
#define		CPU_CLR			49
#define		CPU_CLR1		50
#define		CPU_CLR2		51
#define		CPU_CLR3		52
#define		CPU_CLR4		53
#define		CPU_CLR5		54
#define		CPU_CLR6		55
#define		CPU_CLR7		56
#define		CPU_CLR8		57
#define		CPU_CLR9		58
#define		CPU_CLR10		59
#define		CPU_CLR11		60
#define		CPU_CLR12		61
#define		BCONIN			62
#define		BCONSTAT		63
#define		BCONIN4S		64
#define		CHK_PATH		65
#define		DGETPATH		66
#define		DRVMAP			67
#define		ANZ_ROUT		68

#define		ANZ_CPU_CLR		12

/* und Daten (DATA, BSS	)	*/
#define		B_23E58			0
#define		MEM_L1			1
#define		B_2AD06			2
#define		ANZBOMB			3
#define		GDSEMA1			4
#define		ORSR2			5
#define		PRG_ASP			6
#define		USEOGEM			7
#define		ALTHLP			8
#define		FPUMODE			9
#define		ANZ_DAT			10

/* sonstige Adressen	*/
#define		TXT_AT			0
#define		TXT_AT_F		1
#define		RES_ANY			2
#define		VERS_PTR		3
#define		PD_CFG			4
#define		LW_P			5
#define		ANZ_ADDR		6


/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */
typedef struct
{		UBYTE	*text;		/* Das Textsegment usw	*/
		long	tot_len;	/* Gesamtlnge		*/
		UBYTE	*reloz;		/* Reloziertabelle	*/
		long	rel_len;	/* Lnge der Reloziertabele	*/
		UBYTE 	*data;		/* Datasegment		*/
}PD_ORI;

/* Adresse und Name einer Routine	*/
typedef struct
{	long		addr;
	char		name[30];
}PD_ROUT;

/* Programmheader	*/
typedef struct
{	int		ph_branch;
	long	ph_tlen;			/* Lnge des TEXT-Abschnitts	*/
	long	ph_dlen;			/* Lnge des DATA-Abschnitts	*/
	long	ph_blen;			/* Lnge des BSS-Abschnitts	*/
	long	ph_slen;			/* Lnge des Symboltabelle	*/
	long	ph_res1;			/* reserviert	*/
	long	ph_prgflags;		/* Flags					*/
	int		ph_absflag;			/* 0:Relozierungsinfo vorh.		*/
}PH;

/* Typdefinition fr den Dateiheader einer Borland-Object-Datei */
typedef struct
{	unsigned long magic;		/* 0x4EFA001C */
	unsigned long imageBytes;
	unsigned long symInfoBytes;
	unsigned long nameBytes;
	unsigned long versionInfo;
	unsigned long debugInfo;
	unsigned long reserved1;
	unsigned long reserved2;
} LIBHEADER;

/* neue Routinen...	*/
typedef struct
{	long	reloz[MAX_REL];		/* neue Adressen die reloziert werden mssen	*/
	int 	anz_r;				/* deren Anzahl	*/
	int 	neues[MAX_NR];		/* Nummer fr N_ROUT	*/
	int 	neue;				/* Anzahl neue Routinen	*/
	long	ersetze[MAX_NR][2];	/* Ersetze Adresse[0] durch [1]	*/
	int 	ers;				/* Anzahl zu ersetzender		*/
	long 	reset;				/* Adresse der reset Routine	*/
	long	view_f;				/* Sprung nach Fread in View/File*/
}N_ROUT;
/* Typedefinition fr die Eintrge in der Symboltabelle */
typedef struct
{	char Type; 					/* Typeintrag */
	unsigned char Position; 	/* Offset */
	int Wert; 					/* Name */
} SYMENTRY;
typedef struct
{	char	*sy_name;			/* Name des Symbols					*/
	long	sy_atxt;			/* Adresse relativ zum TEXT Anfang	*/
	char	*sy_aram;			/* aktuelle Adresse im RAM			*/
	SYMENTRY *sy_stab;			/* Beginn in Symboltable			*/
	long	sy_len;				/* Lnge							*/
	int		sy_rel2;			/* relativ zu.fr Entrypoints,sonst-1*/
}SYMB;
typedef struct
{	ULONG	akt_rel;
	long 	st_bss;
	long	diff_bss;
	long	diff_dat;
	long	text_len;
}RELDAT;
typedef struct
{	int		monitore;
	int		setscr;
	int		gemdos;
	int		esc_h;
	int		cash;
	int		pci;
	int		sprache;
	int		laufw;
}OPT_FLAGS;
/* -------------------------------------------------------------------- */
/* 		lokale Funktionsprototypen										*/
/* -------------------------------------------------------------------- */

void fill_DATA(MFDB *m_pd,PDX *x_pd);
void get_lib(char *f_name);
void get_pd(PH *ph,PD_ORI *pd_o);
int find_sym(char *name,int flag);
void einf(int ar_nr,char *nr_name,PH *ph,N_ROUT *n_rout);
int init(void);
void write_new_text(N_ROUT *n_rout);
void suche_rout1(long anz_word,unsigned int p_txt[]);
void suche_dat_bss(unsigned int p_txt[],PH *ph);
void suche_rout2(long anz_word,unsigned int p_txt[]);
void set_namen(void);
void save_addr(void);
void save_addr_txt(void);
int read_addr(void);
void get_addr(PH *ph,PD_ORI *pd_o);
void write_cfg(PD_ORI *pd_o);
void write_new_pd(PH *ph_neu,PH *ph_alt,PD_ORI *pd_o,N_ROUT *n_rout);
void routinen_einf(PH *ph_neu,PD_ORI *pd_o,N_ROUT *n_rout);
void do_rel(PD_ORI *pd_o,ULONG akt_rel,RELDAT *rd,N_ROUT *n_rout);
void insert_jsr(UBYTE *addr,int rout,int len);
void do_opt(void);
void set2RadB(int but0,int but1,int wert);
void set3RadB(int but0,int but1,int but2,int wert);


/* -------------------------------------------------------------------- */
/*		Globale Variablen												*/
/* -------------------------------------------------------------------- */

int Anz_sym=0;
FILE *F_in=NULL,*F_out=NULL;
SYMB Sym[MAX_SYM];
OBJECT *Rsc_adr[2];

long Ndat_len,Nbss_len;
/* Pd_r und Pd_d sind Routinen bzw Daten die teils gendert werden, bzw auf die von den neuen
Routinen zugegriffen wird.
Pd_a sind Adressen an denen etwas gendert wird, die aber nicht explizit bentigt werden.	*/

PD_ROUT Pd_r[ANZ_ROUT],Pd_d[ANZ_DAT],Pd_a[ANZ_ADDR];

char Flag[ANZ_ROUT],Flag_a[ANZ_ADDR],Version_txt[100], File_n[500]="",*Ndat_aram,Prgvers[100]=PRGVERS;
/* Optionen */

OPT_FLAGS Opt_flags;
/* -------------------------------------------------------------------- */
/*		Funktionen														*/
/* -------------------------------------------------------------------- */

/*------------------------------------------------------------------*/
/*			main ( int argc, const char *argv[] )					*/
/*			na was wohl												*/
/*																	*/
/*			wird ein Pfad bergeben, so wird versucht dieses PD		*/
/*			zu patchen, ADDR_DAT wird ignoriert						*/
/*			sonst wird versucht alle Daten aus PD_ADDR.DAT zu lesen	*/
/*		Parameter: 	es kann ein PD_PRG Pfad bergeben werden		*/
/*		Rckgabe : 	0												*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/
int main ( int argc, const char *argv[] )
{	int v_hdl,addr_bek=0;
 	PH	ph_alt,ph_neu;
 	N_ROUT n_rout;
	PD_ORI pd_o;
	if(appl_init()<0)
		exit(-1);
	graf_mouse(0,NULL);
	/* Damit PD_ADDR.DAT auch neu erzeugt wird wenn man nur etwas an patch.c gendert hat
		aber nicht die Versionsnummer gendert hat wird jetzt die Compilierzeit mit gesichert */
		
	strcat(Prgvers," vom: ");
	strcat(Prgvers,__DATE__);
	strcat(Prgvers," um: ");
	strcat(Prgvers,__TIME__);

/* Resource-Files laden */
	if(!rsrc_load("patchrsc.rsc")) exit(-13);
	if(!rsrc_gaddr(R_TREE,OPT_DEUT,&Rsc_adr[OPT_DEUT])) exit(-13);
	if(!rsrc_gaddr(R_TREE,OPT_ENG,&Rsc_adr[OPT_ENG])) exit(-13);

	pd_o.tot_len=0l;
	if(argc>1)
		strcpy(File_n,argv[1]);			/* bergebenes File analysieren	*/
	else
		addr_bek=read_addr();			/* versuchen Adressen aus PD_ADDR.DAT zu lesen	*/
	if(!addr_bek)
	{	get_addr(&ph_alt,&pd_o);		/* dann auf die harte Tour		*/
		save_addr();
		save_addr_txt();
	}


	v_hdl=init();
	do_opt();

	/* Laden	*/
	
	get_lib("PD_LIB.LIB");		/* die neuen Routinen laden			*/
	get_pd(&ph_alt,&pd_o);		/* das Original PD.PRG laden	*/

	ph_neu=ph_alt;						/* noch sind beide gleich	*/
/* Zeiger auf DATA-Bereich und Reloziertabelle	*/

	pd_o.data=&pd_o.text[ph_alt.ph_tlen];
	pd_o.reloz=&pd_o.data[ph_alt.ph_dlen];
	pd_o.rel_len=pd_o.tot_len-ph_alt.ph_tlen-ph_alt.ph_dlen;


/* PD.CFG ->Pi.CFG	mit i=1,2	jedes PD erhlt sein eigenes CFG	*/
	
	pd_o.text[Pd_a[PD_CFG].addr+1l]=(UBYTE)('0'+Opt_flags.monitore);
/* P: -> U:*/
	if(Opt_flags.laufw==2)
		pd_o.text[Pd_a[LW_P].addr]='U';

/* Der Hauptteil	*/
	routinen_einf(&ph_neu,&pd_o,&n_rout);
	write_new_pd(&ph_neu,&ph_alt,&pd_o,&n_rout);
	write_cfg(&pd_o);
	v_clsvwk(v_hdl);
	return(0);

}
/*------------------------------------------------------------------*/
/*	void do_opt(void)												*/
/*																	*/
/*																	*/
/* Hier kann selektiert werden welche Patches ausgefhrt werden		*/
/* sollen. Abgefragt werden nur die, die nicht grundstzlich		*/
/* sinnvoll sind.													*/
/*		Parameter:	keine											*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void do_opt(void)
{
	int x1,y1,w1,h1,but,nochmal;
	FILE *fopt;
	
	fopt=fopen("patch.opt","rb");
	if(fopt)
	{	fread(&Opt_flags,sizeof(OPT_FLAGS),1,fopt);
		fclose(fopt);
	}
	else
	{
		Opt_flags.monitore=1;
		Opt_flags.setscr=1;
		Opt_flags.gemdos=0;
		Opt_flags.esc_h=0;
		Opt_flags.cash=0;
		Opt_flags.pci=0;
		Opt_flags.sprache=OPT_DEUT;
	}

	do
	{	nochmal=0;
		set2RadB(OP_MON1,OP_MON2,Opt_flags.monitore-1);
		set2RadB(OP_K_SS,OP_SETSC,Opt_flags.setscr);
		set2RadB(OP_BIOS,OP_GEMDOS,Opt_flags.gemdos);
		set3RadB(OP_ESCHN,OP_ESCH1,OP_ESCHI,Opt_flags.esc_h);
		set2RadB(OP_KCASH,OP_CASH,Opt_flags.cash);
		set2RadB(OP_K_PCI,OP_PCI,Opt_flags.pci);
		set3RadB(OP_MAX_P,OP_MAX_Z,OP_LW_U,Opt_flags.laufw);
		
		
		wind_update(BEG_MCTRL);
		form_center(Rsc_adr[Opt_flags.sprache],&x1,&y1,&w1,&h1);
		form_dial(FMD_START,x1,y1,w1,h1,x1,y1,w1,h1);
		do
		{
			objc_draw(Rsc_adr[Opt_flags.sprache],0,3,x1,y1,w1,h1);
			but=form_do(Rsc_adr[Opt_flags.sprache],0);
			Rsc_adr[Opt_flags.sprache][but].ob_state &=(~SELECTED);
			if(but==OP_ABBRUCH) break;
	
			Opt_flags.monitore=(Rsc_adr[Opt_flags.sprache][OP_MON2].ob_state &&SELECTED)+1;
			Opt_flags.setscr=(Rsc_adr[Opt_flags.sprache][OP_SETSC].ob_state &&SELECTED);
			Opt_flags.gemdos=(Rsc_adr[Opt_flags.sprache][OP_GEMDOS].ob_state &&SELECTED);
			if(Rsc_adr[Opt_flags.sprache][OP_ESCHI].ob_state &&SELECTED)
				Opt_flags.esc_h=2;
			else
				Opt_flags.esc_h=(Rsc_adr[Opt_flags.sprache][OP_ESCH1].ob_state &&SELECTED);
			Opt_flags.cash=(Rsc_adr[Opt_flags.sprache][OP_CASH].ob_state &&SELECTED);
			Opt_flags.pci=(Rsc_adr[Opt_flags.sprache][OP_PCI].ob_state &&SELECTED);

			if(Rsc_adr[Opt_flags.sprache][OP_LW_U].ob_state &&SELECTED)
				Opt_flags.laufw=2;
			else
				Opt_flags.laufw=(Rsc_adr[Opt_flags.sprache][OP_MAX_Z].ob_state &&SELECTED);
			if(but==OP_SPEICHERN)
			{	fopt=fopen("patch.opt","wb");
				if(fopt)
				{	fwrite(&Opt_flags,sizeof(OPT_FLAGS),1,fopt);
					fclose(fopt);
				}
				else
					form_alert(1,"[1][Kann Optionenfile patch.opt nicht ffnen][Mist]");
			}
			if(but==OP_SPRACHE)
			{
				Opt_flags.sprache=OPT_DEUT+OPT_ENG-Opt_flags.sprache;
				nochmal=1;
			}
		}while(but==OP_SPEICHERN);
		form_dial(FMD_FINISH,x1,y1,w1,h1,x1,y1,w1,h1);
		wind_update(END_MCTRL);
	}
	while(nochmal);
}
/*------------------------------------------------------------------*/
/*	void set2RadB(int but0,int but1,int wert)						*/
/*																	*/
/*																	*/
/* Setzt einen Radiobutton auf selektiert und den anderen auf nicht	*/
/* selektiert. 														*/
/*		Parameter:	but0 wird selektiert wenn wert=0				*/
/*					but1 wird sonst selektiert 						*/
/*					wert s.o.										*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void set2RadB(int but0,int but1,int wert)
{
	if(wert==0)
	{	Rsc_adr[Opt_flags.sprache][but0].ob_state |=SELECTED;
		Rsc_adr[Opt_flags.sprache][but1].ob_state &=(~SELECTED);
	}
	else
	{	Rsc_adr[Opt_flags.sprache][but0].ob_state &=(~SELECTED);
		Rsc_adr[Opt_flags.sprache][but1].ob_state |=SELECTED;
	}
}

/*------------------------------------------------------------------*/
/*	void set3RadB(int but0,int but1,int but2,int wert)						*/
/*																	*/
/*																	*/
/* Setzt einen Radiobutton auf selektiert und d1e anderen auf nicht	*/
/* selektiert. 														*/
/*		Parameter:	but0 wird selektiert wenn wert=0				*/
/*					but1 wird selektiert wenn wert=1				*/
/*					but2 wird sonst selektiert 						*/
/*					wert s.o.										*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void set3RadB(int but0,int but1,int but2,int wert)
{
	switch(wert)
	{
		case 0:
			Rsc_adr[Opt_flags.sprache][but0].ob_state |=SELECTED;
			Rsc_adr[Opt_flags.sprache][but1].ob_state &=(~SELECTED);
			Rsc_adr[Opt_flags.sprache][but2].ob_state &=(~SELECTED);
			break;
		case 1:
			Rsc_adr[Opt_flags.sprache][but0].ob_state &=(~SELECTED);
			Rsc_adr[Opt_flags.sprache][but1].ob_state |=SELECTED;
			Rsc_adr[Opt_flags.sprache][but2].ob_state &=(~SELECTED);
			break;
		case 2:
			Rsc_adr[Opt_flags.sprache][but0].ob_state &=(~SELECTED);
			Rsc_adr[Opt_flags.sprache][but1].ob_state &=(~SELECTED);
			Rsc_adr[Opt_flags.sprache][but2].ob_state |=SELECTED;
			break;
	}
}

/*------------------------------------------------------------------*/
/*void routinen_einf(PH *ph_neu,PD_ORI *pd_o,N_ROUT *n_rout)	*/
/*																	*/
/*																	*/
/* Neue Routinen einbinden, und teilweise alte ersetzen 			*/
/* Rautinen die mit einf(-1,... eingefgt werden sind neue Routinen,*/
/* die i.A. nur von anderen neuen aufgerufen werden, die anderen	*/
/* ersetzen Originalroutinen, in den Komentaren gehe ich meist nur 	*/
/* auf letztere ein													*/
/*		Parameter:	ph_neu Programmheader des neuen PD				*/
/*					pd_o: Infos zum Original PD						*/
/*					n_rout: die neuen Routinen						*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void routinen_einf(PH *ph_neu,PD_ORI *pd_o,N_ROUT *n_rout)
{	
	int i;
	n_rout->anz_r=n_rout->neue=n_rout->ers=0;
	
/* Phys- und Logbase ersetzen	*/
	if(Opt_flags.monitore==2)
	{	einf(PHYSBASE,"Physbase_2",ph_neu,n_rout);
		einf(LOGBASE,"Logbase_2",ph_neu,n_rout);
	}
	
/* v_opnvwk und v_clsvwk ersetzen. Da erstere ganz am Anfang
	aufgerufen wird, finden hier auch sonstige Initialisierungen
	statt. 	*/

	einf(-1,"Supexec_0",ph_neu,n_rout);
	einf(-1,"get_cookie_0",ph_neu,n_rout);
	einf(-1,"get_cookie_jar_0",ph_neu,n_rout);
	einf(-1,"get_act_pd_0",ph_neu,n_rout);
	einf(-1,"init_sup_0",ph_neu,n_rout);
	einf(-1,"emuDate_0",ph_neu,n_rout);
	einf(-1,"set_mpc_comp_0",ph_neu,n_rout);
	einf(-1,"init_0",ph_neu,n_rout);
	einf(MALLOC_H,"malloc_high_0",ph_neu,n_rout);
	
	if(Opt_flags.monitore==2)
	{	einf(-1,"init_sup_2",ph_neu,n_rout);
		einf(-1,"vdi_2",ph_neu,n_rout);
		einf(V_OPNVWK,"v_opn_init_2",ph_neu,n_rout);
		einf(V_CLSVWK,"v_clsbm_2",ph_neu,n_rout);
	}
	else
	{
		einf(V_OPNVWK,"v_opn_init_1",ph_neu,n_rout);
		einf(V_CLSVWK,"v_clsvwk_1",ph_neu,n_rout);
	}
		
/* Fr NOVA-VDI	<2.63 behebt einen Fehler in den teils noch aktuellen
	NOVA-VDI Versionen */
	if(Opt_flags.monitore==2)
	{	einf(VQ_EXTND,"vq_extnd_nova_2",ph_neu,n_rout);

/* Mauszeiger auf 2. Monitor zeichnen, ein/ausschalten	*/

		einf(VQ_MOUSE,"vq_mouse_2",ph_neu,n_rout);
		einf(HIDE_CURS,"hide_curs_2",ph_neu,n_rout);
		einf(SHOW_CURS,"show_curs_2",ph_neu,n_rout);
	}
	
	else	/*	Neuzeichnen der Menzeile auf Mausdruck	bei einem Monitor*/
		einf(VQ_MOUSE,"vq_mouse_1",ph_neu,n_rout);

/* Setscreen und Mxalloc	*/
	if(Opt_flags.monitore==2)
	{	einf(-1,"set_mon_2",ph_neu,n_rout);
		einf(SETSCREEN,"Setscreen_2",ph_neu,n_rout);
		einf(MXALLOC,"Mxalloc_2",ph_neu,n_rout);
	}
	else
	{	einf(MXALLOC,"Mxalloc_1",ph_neu,n_rout);

/*  Benutzung von Setscreen evtl Abstellen	*/
		if(Opt_flags.setscr==0)
			einf(SETSCREEN,"Setscreen_1",ph_neu,n_rout);
	}
	
/*  Tastatureingabe ber Gemdos	*/
	if(Opt_flags.gemdos==1)
	{
	/* Bconstat und Bconin werden nur mit Parameter 2 benutzt -> sie knnen durch 
		Cconis und Crawcin ersetzt werden. 	*/
		
		einf(BCONSTAT,"Cconis_0",ph_neu,n_rout);
		einf(BCONIN,"Crawcin_0",ph_neu,n_rout);
		/* auf Bconin_4s wird per bsr zugegriffen ->am Einfachsten ist es die Routine zu berschreiben */
		pd_o->text[Pd_r[BCONIN4S].addr+2]=0x7;		/* move.w #2,-(sp) durch move.w #7,-(sp) ersetzen*/
		pd_o->text[Pd_r[BCONIN4S].addr+4]=0x4e41;	/* trap 1	*/
		pd_o->text[Pd_r[BCONIN4S].addr+6]=0x548f;	/* addq.l 2,sp*/
		pd_o->text[Pd_r[BCONIN4S].addr+8]=0x4e75;	/*rts 			*/
	}
/* Laufwerke bis Z erlauben*/
	if(Opt_flags.laufw)
	{
		if(	pd_o->text[Pd_r[CHK_PATH].addr+0x15]==0x50);		/* Vergleich mit P*/
			pd_o->text[Pd_r[CHK_PATH].addr+0x15]=0x5A;		/* Durch Vergleich mit Z ersetzen*/
		if(	pd_o->text[Pd_r[CHK_PATH].addr+0x21]==0x70);		/* Vergleich mit p*/
			pd_o->text[Pd_r[CHK_PATH].addr+0x21]=0x7A;		/* Durch Vergleich mit z ersetzen*/
	}
	if(Opt_flags.laufw==2)
	{
		einf(DGETPATH,"Dgetpath_0",ph_neu,n_rout);
		einf(DRVMAP,"Drvmap_0",ph_neu,n_rout);
	}


/*  Vektoren mit XBRA verbiegen	*/
	einf(-1,"tst_id_0",ph_neu,n_rout);
	einf(SETMYEXC,"set_my_exc_x",ph_neu,n_rout);
	einf(RESMYEXC,"res_my_exc_x",ph_neu,n_rout);
	einf(SETGDT,"set_gd_trm_x",ph_neu,n_rout);
	einf(SETEXC,"set_etvc_x",ph_neu,n_rout);
	einf(-1,"tst_1sysv_x",ph_neu,n_rout);
	einf(-1,"tst_sysv_x",ph_neu,n_rout);
	einf(-1,"tst_sysva_x",ph_neu,n_rout);
	einf(MFREEL1,"mfree_l1_0",ph_neu,n_rout);
	einf(MFREEAS,"mfree_a_sp_0",ph_neu,n_rout);
	einf(-1,"res_sysv_x",ph_neu,n_rout);
	einf(RESGDT,"res_gd_trm_x",ph_neu,n_rout);
	einf(SETHCV,"set_hcop_vb_x",ph_neu,n_rout);
	einf(RESHCV,"res_hcop_vb_x",ph_neu,n_rout);

/*  Bei Reset auch Fclose() ausfhren 
	PD springt nicht nur per jsr, sondern auch per bsr in diese Routine,
	da diese Sprnge nicht erkannt werden, berschreibe ich unten den
	Anfang der Routine mit:
	nop
	jmp reset
	Durch das nop kommt reset an eine Speicherstelle, an der auch im Original
	eine absolute Adresse steht, somit braucht die Reloziertabelle nicht
	angepat zu werden.	Dadurch kann ich natrlich nicht mehr nach reset
	springen, sondern nur noch in den ungenderten Teil (reset_a)		*/

	n_rout->reset=ph_neu->ph_tlen;
	einf(RESET,"reset_0",ph_neu,n_rout);
	
/*	In View/File fehlt ein Fclose. Ich ersetze dort und nur dort den
	Aufruf von Fread durch den auf Fread_close, da ein Fread und ein
	Fclose durchfhrt.	*/
	n_rout->view_f=ph_neu->ph_tlen;
	einf(-1,"Fread_close_0",ph_neu,n_rout);

/*  Ausgabe von ESC H (Cursor home) evtl Abstellen	*/
	if(Pd_r[ESC_H_ETC].addr)
	{	switch( Opt_flags.esc_h)
		{	case 0:	/* nie*/
				pd_o->text[Pd_r[ESC_H_ETC].addr+6]=0x60;		/* bne durch bra ersetzen*/
				break;
			case 2: /* immer */
				pd_o->text[Pd_r[ESC_H_ETC].addr+6]=0x6b;		/* bne durch bmi ersetzen*/
				break;
		}
	}
	else
		form_alert(1,"[1][Kann ESC H Korektur nicht ausfhren,| da Adresse unbekannt ][ OK ]");

/*	An einigen Stellen ist es ntig den CPU-Cache zu lschen, dies ist vor allem bei
	MAC's ntig aber sicher nicht nur dort dafr ist es ntig den CPU-Typ zu
	ermitteln. Dieser Patch unterscheidet sich von allen bisherigen, da nicht
	ein JSR verbogen sondern neu eingefgt wird. Deshalb mu die Relloziertabelle
	angepat werden
	*/

	if(Opt_flags.cash==1)
	{
		for(i=0;i<ANZ_CPU_CLR;i++)
		{	n_rout->reloz[n_rout->anz_r++]=Pd_r[CPU_CLR+1+i].addr+2l;
			insert_jsr(&pd_o->text[Pd_r[CPU_CLR+1+i].addr],CPU_CLR,6);
		}
		einf(CPU_CLR,"clear_cpu_0",ph_neu,n_rout);
		einf(-1,"get_cpu_0",ph_neu,n_rout);
	}

/* Der sog. PCI-Patch. PCI-MAC's haben Probleme mit der im Startupcode
	vorhandenen FPU Erkennung	*/
	if(Opt_flags.pci==1)
	{	
		einf(FPUINIT,"fpu_init_m",ph_neu,n_rout);
	}


	if(n_rout->neue>=MAX_NR)
	{	form_alert(1,"[3][MAX_NR mu erhht werden!][Mach ich]");
		exit(0);
	}
}


void insert_jsr(UBYTE *addr,int rout,int len)
{	UWORD* addr_w;
	int i;
	addr_w=(UWORD *)addr;
	addr_w[0]=0x4eb9;			/* jsr #.l	*/
	*(ULONG *)&addr_w[1]=Pd_r[rout].addr;
	if(len<3)
	{	form_alert(1,"[2][Na 6 Byte whren fr ein JSR|doch nicht zuviel oder?][Bis dann]");
		exit(0);
	}
	for(i=3;i<len;i++)
		addr_w[i]=0x4e71;			/* NOP	*/
}

/*------------------------------------------------------------------*/
/*void write_new_pd(PH *ph_neu,PH *ph_alt,PD_ORI *pd_o,N_ROUT *n_rout)	*/
/*																	*/
/*																	*/
/* neues PD zusammenbasteln und schreiben							*/	
/*		und zwar in der Reihenfolge:								*/
/*		- TEXT aus PD.PRG											*/
/*		- TEXT aus PD_LIB.LIB										*/
/*		- DATA aus PD.PRG											*/
/*		- M_PD	(in der 2Monitorversion)							*/
/*		- X_PD														*/
/*		- DATA aus PD_LIB.LIB										*/
/*		- BSS aus PD.PRG											*/
/*		- BSS aus PD_LIB.LIB										*/
/*		- Reloziertabelle											*/
/*		die BSS werden natrlich nicht geschrieben					*/
/*		Parameter:	ph_neu Programmheader des neuen PD				*/
/*					ph_alt Programmheader des alten PD				*/
/*					pd_o: Infos zum Original PD						*/
/*					n_rout: die neuen Routinen						*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void write_new_pd(PH *ph_neu,PH *ph_alt,PD_ORI *pd_o,N_ROUT *n_rout)
{ 	unsigned char offs;
	OBJECT *prginf;
	TEDINFO *tedinf[6];
	long rel_4_t,rel_4_to,akt_rel,lst_rel,
		lst_t_rel,addr,st_data,pos_xpd;
	int i,an_rel=0,rel_anz=0;
	MFDB m_pd;
	PDX x_pd;
	RELDAT rd;
	ULONG *rel_tab;



/* in Programm Info ist die Anzeige fr Text at:,... nur 6 Hexzeichen lang, sie mu 8 lang sein*/
/* Teil 1: Adressen ermitteln, Zahlenwerte ersetzen aber noch nicht die neuen Adressen einsetzen,
	da diese sonst im nchsten Schritt falsch korigiert wrden.	*/
	prginf=(OBJECT *)&pd_o->text[Pd_a[TXT_AT].addr];
	pd_o->text[Pd_a[TXT_AT_F].addr+2]='8';	/*	Formatstring: %06lX ndern in: %08lX	*/
	for(i=0;i<6;i++)
	{	prginf[i*2].ob_width=9;		/* Objektbreite 7->9 */
		tedinf[i]=(TEDINFO*)&pd_o->text[(long)prginf[i*2].ob_spec.tedinfo];	/* die Position der 6 tedinfos im RAM merken*/
		tedinf[i]->te_txtlen=9;		/* Text und Maskenbreite um 2 erhhen */
		tedinf[i]->te_tmplen=10;
	}	

/*	Verschieben der Adressen von DATA aus PD.PRG um:				*/

	rd.diff_dat=ph_neu->ph_tlen-ph_alt->ph_tlen;

/* Zustzliches DATA einfgen		*/

	if(Opt_flags.monitore==2)
	{	Sym[find_sym("M_pd",1)].sy_atxt=ph_neu->ph_tlen+ph_neu->ph_dlen;
		ph_neu->ph_dlen+=sizeof(MFDB);
	}
	
	pos_xpd=Sym[find_sym("X_pd",1)].sy_atxt=ph_neu->ph_tlen+ph_neu->ph_dlen;
	ph_neu->ph_dlen+=sizeof(PDX);

/* Verweise in neuen TEXT auf DATA,BSS aus PD_LIB.	sy_atext enthlt den Abstand zum
	Segmentbeginn, es mu also der Segmentbeginn hinzuaddiert werden. Auerdem
	ist dies ein guter Ort um die Global Entrypoints von der relativen Adressierung zur
	absoluten zu ndern	*/

	st_data=ph_neu->ph_tlen+ph_neu->ph_dlen;
	ph_neu->ph_dlen+=Ndat_len;
	rd.st_bss=ph_neu->ph_tlen+ph_neu->ph_dlen+ph_neu->ph_blen;
	ph_neu->ph_blen+=Nbss_len;
	
	for(i=0;i<Anz_sym;i++)
	{	switch(Sym[i].sy_rel2)
		{	case -1:			/* normal		*/
				break;
			case -2:			/* neues Data	*/
				Sym[i].sy_atxt+=st_data;
				Sym[i].sy_rel2=-1;
				break;
			case -3:			/* neues BSS	*/
				Sym[i].sy_atxt+=rd.st_bss;
				Sym[i].sy_rel2=-1;
				break;
			default:			/* Global Entrypoint	*/
				if(Sym[Sym[i].sy_rel2].sy_atxt)	/* Funktionsanfang	*/
				{	Sym[i].sy_atxt+=Sym[Sym[i].sy_rel2].sy_atxt;
					Sym[i].sy_rel2=-1;
				}
				else
					Sym[i].sy_atxt=0l;
		}
	}

/*	Verschieben der Adressen von BSS aus PD.PRG	um:			*/

	rd.diff_bss=rd.diff_dat+ph_neu->ph_dlen-ph_alt->ph_dlen;

	rd.st_bss=ph_alt->ph_tlen+ph_alt->ph_dlen;			/* Start von BSS in PD.PRG	*/
	
	
/* Verweise in neuen TEXT auf alte DATA,BSS	*/

	for(i=0;i<ANZ_DAT;i++)
	{	if(Pd_d[i].addr<rd.st_bss)		/* DATA	*/
			Sym[find_sym(Pd_d[i].name,1)].sy_atxt=Pd_d[i].addr+rd.diff_dat;
		else						/* BSS	*/
			Sym[find_sym(Pd_d[i].name,1)].sy_atxt=Pd_d[i].addr+rd.diff_bss;
	}


/*	In altem TEXT Sprungadressen nach DATA,BSS und auf genderte 
		Funktionen verschieben und Stelle in Reloziertabelle merken,
		an der das TEXT-Segment endet (lst_rel)	
		Die Reloziertabelle beginnt mit der ersten Adresse wo eine absolute
		Adresse steht (long) und dann jeweils offsets bis zur nchsten (Byte)*/

	lst_rel=*((long *)pd_o->reloz);
	lst_rel&=0xffffff00l;			/*	So braucht die erste Adresse nicht als Sonderfall behandelt zu werden*/
	if((rel_tab=malloc(	(pd_o->rel_len+n_rout->anz_r+1000)*sizeof(ULONG)))==NULL)
	{	form_alert( 1,"[1][Nicht genug Speicher][Abbruch]");
		exit(0);
	}
	n_rout->reloz[n_rout->anz_r]=0x7fffffffl;
	rd.text_len=ph_alt->ph_tlen;
	
/*	n_rout->reloz mu sortiert werden, sobald es nicht nur fr CPU_CLR benutzt wird*/
	for(i=3;i<pd_o->rel_len;i++)
	{	if(pd_o->reloz[i]==1)		/* Offset 1 bedeutet da 254 Byte nichts kommt*/
			akt_rel=lst_rel+254l;
		else
		{	akt_rel=lst_rel+(long)pd_o->reloz[i];
			while(akt_rel>n_rout->reloz[an_rel])
			{	rel_tab[rel_anz++]=n_rout->reloz[an_rel];
				do_rel(pd_o,n_rout->reloz[an_rel++],&rd,n_rout);
			}
			rel_tab[rel_anz++]=akt_rel;
			do_rel(pd_o,akt_rel,&rd,n_rout);
		}
		if(akt_rel>=ph_alt->ph_tlen && lst_rel<ph_alt->ph_tlen)	/*altes TEXT fertig	*/
		{	rel_4_t=rel_anz-1;		/* Anzahl Reloziereintrge fr text	neu*/
			rel_4_to=i;				/* Anzahl Reloziereintrge fr text	alt*/
			
			lst_t_rel=lst_rel;		/* letzter Reloziereintrag fr text	(Adressse)*/ 
		}
		lst_rel=akt_rel;
	}
	n_rout->anz_r=0;


/* in Programm Info ist die Anzeige fr Text at:,... nur 6 Hexzeichen lang, sie mu 8 lang sein
	Teil 2: hier jetzt die Adressen innerhalb X_pd einsetzen	*/
	for(i=0;i<6;i++)
	{	tedinf[i]->te_ptext=(char *)(pos_xpd+((long)&x_pd.p_prginf[i][0][0]-(long)&x_pd));
		tedinf[i]->te_ptmplt=(char *)pos_xpd+((long)&x_pd.p_prginf[i][1][0]-(long)&x_pd);
		tedinf[i]->te_pvalid=(char *)pos_xpd+((long)&x_pd.p_prginf[i][2][0]-(long)&x_pd);
	}
						
/* Einfgen von jmp auf reset in Originalroutine auf neue Routine		*/
	if(Pd_r[RESET].addr)
	{	*(int  *)&pd_o->text[Pd_r[RESET].addr  ]=0x4e71;		/* nop		*/
		*(int  *)&pd_o->text[Pd_r[RESET].addr+2]=0x4ef9;		/* jmp		*/
		*(long *)&pd_o->text[Pd_r[RESET].addr+4]=n_rout->reset;		/* reset	*/
	}
	else
		form_alert(1,"[1][Kann Fclose bei Programm Reset| nicht einfgen, da die Adresse| unbekannt ist][ OK ]");

	if(Pd_r[VIEW_F].addr)
		*(long  *)&pd_o->text[Pd_r[VIEW_F].addr  ]=n_rout->view_f;		/* Fread_close	*/
	else
		form_alert(1,"[1][Kann Fread_close bei View/File| nicht einfgen, da die Adresse| unbekannt ist][ OK ]");

	/* TEXT schreiben	*/
	fwrite(ph_neu,sizeof(PH),1,F_out);		/* neuer Header				*/
	fwrite(pd_o->text,1,ph_alt->ph_tlen,F_out);	/*gendertes altes TEXT Segment	*/
	write_new_text(n_rout);							/* die neuen Routinen		*/

	/* DATA Schreiben	*/

	fwrite(pd_o->data,1,ph_alt->ph_dlen,F_out);	/*DATA Segment von PD.PRG schreiben	*/
 	fill_DATA(&m_pd,&x_pd);				/* die neuen DATA's initialisieren	*/
	if(Opt_flags.monitore==2)
		fwrite(&m_pd,1,sizeof(MFDB),F_out);		/*neues DATA fr 2 Monitorbetrieb	*/
	fwrite(&x_pd,1,sizeof(PDX),F_out);			/*neues DATA				*/
	fwrite(Ndat_aram,1,Ndat_len,F_out);			/*neues DATA aus PD_LIB				*/
	
	/* Reloziertabelle schreiben	*/

	/*Realloziertabelle fr TEXT von PD.PRG schreiben	*/

	fwrite(rel_tab,sizeof(ULONG),1,F_out);			/*Der Start	*/
	lst_t_rel=rel_tab[0];
	for(i=1;i<rel_4_t;i++)
	{	while(rel_tab[i]!=lst_t_rel)
		{	if((rel_tab[i]-lst_t_rel)>254)
			{	offs=1;
				lst_t_rel+=254;
			}
			else
			{	offs=(unsigned char)(rel_tab[i]-lst_t_rel);
				lst_t_rel=rel_tab[i];
			}
			fwrite(&offs,1,1,F_out);					/* weiteres Offset anfgen	*/
		}
	}
	/* Realloziertabelle fr neue Routinen erzeugen	*/

	n_rout->reloz[n_rout->anz_r++]=rel_tab[rel_4_t]+rd.diff_dat;	/*die 1. Adresse in DATA	*/
	for(i=0;i<n_rout->anz_r;i++)
	{	addr=n_rout->reloz[i];
		while(addr!=lst_t_rel)
		{	if((addr-lst_t_rel)>254)
			{	offs=1;
				lst_t_rel+=254;
			}
			else
			{	offs=(unsigned char)(addr-lst_t_rel);
				lst_t_rel=addr;
			}
			fwrite(&offs,1,1,F_out);					/* weiteres Offset anfgen	*/
		}
	}

	/*Realloziertabelle fr DATA von PD.PRG schreiben, das neue DATA enthlt
		keine Adressen ->keine Reloziertabelle	*/
	rel_4_to++;
	fwrite(&pd_o->reloz[rel_4_to],1,pd_o->rel_len-rel_4_to,F_out);
	fclose(F_out);
}



void do_rel(PD_ORI *pd_o,ULONG akt_rel,RELDAT *rd,N_ROUT *n_rout)
{	long *rel_addr;
	int j;
	rel_addr=(long *)&pd_o->text[akt_rel];
	if((*rel_addr)>=rd->st_bss)					/* Zeiger auf BSS	*/
		*rel_addr+=rd->diff_bss;
	else
	{	if((*rel_addr)>=rd->text_len)	/* Zeiger auf DATA */
			*rel_addr+=rd->diff_dat;
		else								/* Zeiger auf TEXT bleiben, es sei denn die Funktion wurde ersetzt	*/
		{	for(j=0;j<n_rout->ers;j++)
			{	if(*rel_addr==n_rout->ersetze[j][0])	/* Zeiger auf genderte Funktion	*/
					*rel_addr=n_rout->ersetze[j][1];
			}
		}
	}
}
/*------------------------------------------------------------------*/
/*			void write_cfg(PD_ORI *pd_o)				*/
/*																	*/
/*																	*/
/* 		PD.CFG nach Pi.CFG kopieren, und dabei ggf auf 				*/
/*		ALLWAYS ADDRESS setzen										*/
/*		Parameter: 	pd_o wird nur benutzt um den Speicherplatz 		*/
/*						von text zu	benutzen						*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void write_cfg(PD_ORI *pd_o)
{	
	FILE *fi_cfg,*fo_cfg;
	char dat_n[50]="PD.CFG";
	long c_len;

	/* PD.CFG bestimmen	*/
	build_filename(File_n,File_n,"PD.CFG");

	while((fi_cfg=fopen(File_n,"rb"))==NULL)
	{	strcpy(strrchr(File_n,'\\')+1,"*.CFG");
		if(!easy_fsel(File_n,dat_n,"PD.CFG aussuchen1"))
			exit(0);
		build_filename(File_n,File_n,dat_n);
	}

	/* neues CFG bestimmen	*/
	if(Opt_flags.monitore==2)
		build_filename(File_n,File_n,"P2.CFG");
	else
		build_filename(File_n,File_n,"P1.CFG");

	/* Das cfg nur schreiben, wenn nicht bereits eines existiert, sonst
	gehen jedesmal alle Einstellungen verloren	*/
	if(!exist(File_n))
	{	c_len=fread(pd_o->text,1,pd_o->tot_len,fi_cfg);
		fclose(fi_cfg);
		if(Opt_flags.monitore==2)
			pd_o->text[7]=pd_o->text[21]='\0';		/*Switch always by adress	*/
		if((fo_cfg=fopen(File_n,"wb"))==NULL)
		{	form_alert(1,"[3][Kann neues PD.CFG nicht schreiben][Schade]");
			exit(0);
		}
		fwrite(pd_o->text,1,c_len,fo_cfg);
		fclose(fo_cfg);
	}
}


/*	ar_ sind Variablen die mit den Alten Routinen zusammenhngen
	nr_ sind Variablen die mit den Neuen Routinen zusammenhngen
	
	hier werden Routinen eingefgt (nur ber Pointer) auerdem kann eine
	Original PD-Routine (ar_nr) angegeben werden, die durch die neue
	(nr_name) ersetzt wird.	Dies klappt allerdings bisher nur, wenn
	die Routine durch einen Absoluten Call aufgerufen wird, nicht bei
	bsr u.., da nur die Adressen der Reloziertabelle benutzt werden */

void einf(int ar_nr,char *nr_name,PH *ph,N_ROUT *n_rout)
{	int nr_nr;
	char fehler[100];
	nr_nr=find_sym(nr_name,1);
	Sym[nr_nr].sy_atxt=ph->ph_tlen;		/*Adresse relativ zu Programmanfang*/
	n_rout->neues[n_rout->neue++]=nr_nr;
	if(ar_nr>-1)						/* ersetzen?	*/
	{	if(Pd_r[ar_nr].addr)
		{	n_rout->ersetze[n_rout->ers][0]=Pd_r[ar_nr].addr;
			n_rout->ersetze[n_rout->ers++][1]=Sym[nr_nr].sy_atxt;
		}
		else
		{	sprintf(fehler,"[1][Beim Ersetzen von %s ist die|Adresse der Originalroutine unbekannt ][Abbruch]",Pd_r[ar_nr].name);
			form_alert( 1,fehler);
			exit(0);
		}
	}
	ph->ph_tlen+=Sym[nr_nr].sy_len;
}

/*------------------------------------------------------------------*/
/*			void write_new_text(N_ROUT *n_rout)						*/
/*																	*/
/*																	*/
/*		hier werden die neuen Routinen geschrieben (File) und		*/
/*		gleichzeitig die Adressen eingesetzt (mit der Symboltabelle)*/
/*		ar_ sind Variablen die mit den Alten Routinen zusammenhngen*/
/*		nr_ sind Variablen die mit den Neuen Routinen zusammenhngen*/
/*		Parameter: 	die neuen Routinen								*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void write_new_text(N_ROUT *n_rout)
{	char fehler[100],*ptr;
 	long pos,delta;
 	SYMENTRY *sym_e;
	int i,j,nr_nr,weiter,err=0,ziel_err;
	for(j=0;j<n_rout->neue;j++)				/* die neuen Routinen	*/
	{	nr_nr=n_rout->neues[j];
		pos=Sym[nr_nr].sy_atxt;			/* Adresse relativ zu TEXT-Anfang	*/
		ptr=&Sym[nr_nr].sy_aram[-pos];	/* Hilfspointer	*/
		if((sym_e=Sym[nr_nr].sy_stab)==NULL)
		{	sprintf(fehler,"[1][%s ist nicht global definiert][Abbruch]",Sym[nr_nr].sy_name);
			form_alert( 1,fehler);
			exit(0);
		}	
		weiter=1;
		for(i=0;weiter;i++)		/* Die Symboltabelle durchgehen	*/
		{	pos+=sym_e[i].Position;
			switch((int)sym_e[i].Type)
			{	case 2:			/*Advance eigentl *256 aber 1* ist schon */
					pos+=(int)sym_e[i].Position*255;
					break;
				case 4:			/*Start new data segment: */
				case 7:			/*Define new global module: */
				case 9:			/*Define new local module: */
					weiter=0;	/*Neue Routine	*/
					break;
				case 11:		/*Absolut long reference to: */
					if(!Sym[sym_e[i].Wert].sy_atxt)	
					{	ziel_err=i;
						weiter=0;
						if(Sym[sym_e[i].Wert].sy_rel2!=-1)
							err=3;
						else
							err=1;
					}
					else
					{	*(long *)&ptr[pos]+=Sym[sym_e[i].Wert].sy_atxt;
						n_rout->reloz[n_rout->anz_r++]=pos;
					}
					break;
				case 14:		/*PC-relative word reference to: */
					if(Sym[sym_e[i].Wert].sy_atxt==0l)
					{	ziel_err=i;
						if(Sym[sym_e[i].Wert].sy_rel2!=-1)
							err=3;
						else
							err=1;
						weiter=0;
					}
					else
					{	delta=(Sym[sym_e[i].Wert].sy_atxt-pos);
						if(labs(delta)<0x7ffel)
							*(int *)&ptr[pos]=(int)delta;
						else
						{	err=2;
							ziel_err=i;
						}
						
					}
					break;
				case 1:			/*End of object */
				case 3:			/*Start new text segment: */
				case 5:			/*Start new bss segment: */
				case 6:			/*Start new offset segment: */
					sprintf(fehler,"[1][%s| hat einen unerwarteten|Eintrag in Symboltabelle|bzw an unerwarteter Stelle][Abbruch]",Sym[nr_nr].sy_name);
					form_alert( 1,fehler);
					exit(0);
					break;		/*hier ignorieren	*/
			}
		}
		switch(err)
		{	case 0:	/* alles OK	*/
				break;
			case 2:	/* relativer Sprung zu gro	*/
				sprintf(fehler,"[3][Der Verwei von '%s'|nach '%s'|ist fr einen relativen Sprung zu gro.][Abbruch]",Sym[nr_nr].sy_name,Sym[sym_e[ziel_err].Wert].sy_name);
				form_alert( 1,fehler);
				exit(0);
				break;
			case 1:
				sprintf(fehler,"[3][Beim Einfgen von '%s'|ist die Adresse von '%s'|unbekannt ][Abbruch]",Sym[nr_nr].sy_name,Sym[sym_e[ziel_err].Wert].sy_name);
				form_alert( 1,fehler);
				exit(0);
				break;
			case 3:
				sprintf(fehler,"[3][Beim Einfgen von '%s'|ist die Adresse von '%s'|nur relativ zu %s|bekannt.][Abbruch]",Sym[nr_nr].sy_name,Sym[sym_e[ziel_err].Wert].sy_name,Sym[Sym[sym_e[ziel_err].Wert].sy_rel2].sy_name);
				form_alert( 1,fehler);
				exit(0);
				break;
		}
		fwrite(Sym[nr_nr].sy_aram,1,Sym[nr_nr].sy_len,F_out);	/*die neuen Routinen	*/
		
	}
	if(n_rout->anz_r>=MAX_REL)
	{	form_alert(1,"[3][MAX_REL mu erhht werden!][Mach ich]");
		exit(0);
	}
}

/*------------------------------------------------------------------*/
/*			void fill_DATA(MFDB *m_pd,PDX *x_pd)					*/
/*																	*/
/*																	*/
/*	Hier werden die Globalen Daten gesetzt.							*/
/*  Dieses Patchprogramm verkraftete frher noch kein DATA-Segment	*/
/*	aus PD_LIB.LIB. Deshalb muen alle Daten in die als extern		*/
/*	deklarierten Strukturen X_pd und M_pd gelegt werden				*/
/*	Jetzt knnen zwar DATA und BSS benutzt werden, aber:			*/
/*	"never change a running system"									*/
/*	Auerdem habe ich da noch Neuerungen vor, die so einfacher sind.*/
/*	PD luft lt. Handbuch nur in hoher Auflsung, aus Erfahrung aber*/
/*	auch in TT-MID, 1024*768*8,.... Sinnvoll sind von den 			*/
/*	Standardauflsungen also nur ST-High(2) und TT-MID(4). Trotzdem	*/
/*	funktioniert bei mir fr den Zweimonitorbetrieb nur ST-HIGH,	*/
/*	und zwar weil das NOVA-VDI keine 4-Bit Bitmaps untersttzt.		*/
/*	v_opnbm gibt also Handle 0 zurck, dies wird von PD aber nicht 	*/
/*	getestet, sondern es wird normal vq_extnd aufgerufen.			*/
/*	Dieses gibt dann als Auflsung 0*0 zurck, da erscheint PD 	*/
/*	etwas wenig, und er gibt die Meldung aus, da er nicht in LOW	*/
/*	luft. Selbst wenn ein anderer VDI-Triber 4 Planes untersttzt, */
/*	ist es recht unwahrscheinlich, da er auch das seltsame			*/
/*	ATARI-Format anwendet. Wahrscheinlich bleibt also nur ST-HIGH.	*/
/*  Man knnte natrlich den Treiber 1-Plane ausgeben lassen, und 	*/
/*	dies selber	nach 4 Plane ATARI wandeln, aber das drfte einiges */
/*	an Zeit	verbrauchen.											*/
/*		Parameter: 	die beiden zu fllenden Strukturen				*/
/*		Rckgabe : 	keine, bzw der Inhalt gefllten Strukturen		*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void fill_DATA(MFDB *m_pd,PDX *x_pd)
{	int i;
	memset(x_pd,0,sizeof(PDX));
	memset(m_pd,0,sizeof(MFDB));
	x_pd->p_x=-1;
	x_pd->p_res=2;					/* Auflsung, s.o.	*/
	x_pd->p_mmaske[0]=0xc000a000l;
	x_pd->p_mmaske[1]=0x90008800l;
	x_pd->p_mmaske[2]=0x84008200l;
	x_pd->p_mmaske[3]=0x81008080l;
	x_pd->p_mmaske[4]=0x80408020l;
	x_pd->p_mmaske[5]=0x801081f0l;
	x_pd->p_mmaske[6]=0x89009480l;
	x_pd->p_mmaske[7]=0xa480c380l;
	x_pd->p_mzeiger[0]=0x00004000l;
	x_pd->p_mzeiger[1]=0x60007000l;
	x_pd->p_mzeiger[2]=0x78007c00l;
	x_pd->p_mzeiger[3]=0x7e007f00l;
	x_pd->p_mzeiger[4]=0x7f807fc0l;
	x_pd->p_mzeiger[5]=0x7fe07e00l;
	x_pd->p_mzeiger[6]=0x76006300l;
	x_pd->p_mzeiger[7]=0x43000000l;
	x_pd->p_vopn=0;
	x_pd->p_nova_alt=0;

	x_pd->p_cpu=-1;
	
	for(i=0;i<6;i++)
	{	strcpy(x_pd->p_prginf[i][0],"________");
		strcpy(x_pd->p_prginf[i][1],"$________");
		strcpy(x_pd->p_prginf[i][2],"XXXXXXXX");
	}
	m_pd->fd_w=640;
	m_pd->fd_h=400;
	m_pd->fd_nplanes=1;
	m_pd->fd_wdwidth=m_pd->fd_w/16;
	
}
/*------------------------------------------------------------------*/
/*			void get_lib(char *f_name)								*/
/*																	*/
/*																	*/
/* Ldt die LIB der neuen Funktionen, incl. Symboltabelle			*/
/*		Parameter: 	neuer Programmheader							*/
/*					Pfad der LIB und Anzahl Monitore				*/
/*		Rckgabe : 	nur in globalen Var.							*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void get_lib(char *f_name)
{	FILE *f_obj;
 	LIBHEADER lh;
	SYMENTRY *sym_e;
 	char fehler[200],*o_txt,*rel2_a=NULL;
 	long rest,len,pos=0l,s_bss=0l,s_data=0l;
	int i,anz_ent,lst,s_len,ep,sym,rel2_i=-1;
	f_obj=fopen(f_name,"rb");
	if(!f_obj)
	{	sprintf(fehler,"[1][Kann %s|nicht ffnen][Abbruch]",f_name);
		form_alert( 1,fehler);
		exit(0);
	}
	fread(&lh,sizeof(LIBHEADER),1,f_obj);	/* Header des Objectfiles	*/
	if(lh.magic!=MAGIC)
	{	sprintf(fehler,"[1][Kann %s|nicht verstehen][Abbruch]",f_name);
		form_alert( 1,fehler);
		exit(0);
	}
	len=lh.imageBytes+lh.symInfoBytes+lh.nameBytes+1;
	if((o_txt=malloc(len))==NULL)
	{	form_alert( 1,"[1][Nicht genug Speicher][Abbruch]");
		exit(0);
	}
	fread(o_txt,1,len,f_obj);	/* IMAGE+SYMBOLS  von *.lib laden	*/
	fclose(f_obj);
	/* In der Lib wird immer die XBRA Kennung 'PDeb' verwendet 
		fr die 2 Monitor-Version soll aber PDEB verwendet werden*/
	if(Opt_flags.monitore==2)
	{	for(i=0;i<lh.imageBytes;i+=2)
		{	if(!memcmp(&o_txt[i],"XBRAPDeb",8))
				memcpy(&o_txt[i+6],"EB",2);
		}
	}
	/* Symboltabelle laden	*/
	rest=lh.nameBytes;
	Sym[0].sy_name=&o_txt[lh.imageBytes+lh.symInfoBytes+1];
	while(rest)
	{	s_len=(int)Sym[Anz_sym].sy_name[-1];
		Sym[Anz_sym].sy_name[-1]='\0';
		rest-=(long)(s_len+1);
		Sym[Anz_sym+1].sy_name=&Sym[Anz_sym].sy_name[s_len+1];
		if(!s_len)
			Sym[Anz_sym].sy_name--;
		Sym[Anz_sym].sy_rel2=rel2_i;
		Sym[Anz_sym++].sy_atxt=0;
	}
	if(Anz_sym>=MAX_SYM-1)	/* kann nur whrend der Entwicklungsphase vorkommen*/
	{	sprintf(fehler,"[3][zu viele Symbols, erhhe MAX_SYM|auf mindestens:%i][Schade]",Anz_sym);
		form_alert(1,fehler);
		exit(0);
	}

	/* Symboltabelle analysieren	*/
	
	Sym[Anz_sym-1].sy_name[s_len]='\0';
	sym_e=(SYMENTRY *)&o_txt[lh.imageBytes];
	anz_ent=(int)(lh.symInfoBytes/sizeof(SYMENTRY));
	lst=Anz_sym;		/* da strt's nicht mehr	*/
	for(i=0;i<anz_ent;i++)
	{	pos+=sym_e[i].Position;
		switch((int)sym_e[i].Type)
		{	case 1:			/*End of object */
				Nbss_len=pos-s_bss;
				break;
			case 2:			/*Advance eigentl *256 aber 1* ist schon */
				pos+=(int)sym_e[i].Position*255;
				break;
			case 4:			/*Start new data segment: */
				Sym[lst].sy_len+=pos;
				lst=MAX_SYM-1;
				Ndat_aram=(char *)&o_txt[pos];
				s_data=pos;
				rel2_a=(char *)&o_txt[pos];
				rel2_i=-2;
				break;
			case 5:			/*Start new bss segment: */
				Sym[lst].sy_len+=pos;
				lst=MAX_SYM-1;
				Ndat_len=pos-s_data;
				s_bss=pos;
				rel2_a=(char *)&o_txt[pos];
				rel2_i=-3;
				break;
			case 7:			/*Define new global module: */
			case 9:			/*Define new local module: */
				Sym[lst].sy_len+=pos;
				lst=sym_e[i].Wert;
				Sym[lst].sy_aram=(char *)&o_txt[pos];
				Sym[lst].sy_atxt=Sym[lst].sy_aram-rel2_a;
				Sym[lst].sy_stab=&sym_e[i+1];
				Sym[lst].sy_len=-pos;
				Sym[lst].sy_rel2=rel2_i;
				break;
			case 8:			/*Global entrypoint: */
				ep=sym_e[i].Wert;
				Sym[ep].sy_aram=(char *)&o_txt[pos];
				Sym[ep].sy_stab=&sym_e[i+1];
				Sym[ep].sy_len=0l;
				Sym[ep].sy_atxt=Sym[ep].sy_aram-Sym[lst].sy_aram;
				Sym[ep].sy_rel2=lst;
				break;
			case 3:			/*Start new text segment: */
			case 6:			/*Start new offset segment: */
			case 11:		/*Absolut long reference to: */
			case 14:		/*PC-relative word reference to: */
			case 10:		/*Local entrypoint: */
				break;		/*hier ignorieren	*/
			default:
				sprintf(fehler,"[1][%s|enthlt Symboltyp: %i][Abbruch]",f_name,(int)sym_e[i].Type);
				form_alert( 1,fehler);
				exit(0);
				break;
		}
	}
	for(i=0;i<ANZ_ROUT;i++)
	{	if((sym=find_sym(Pd_r[i].name,0))>-1)
			Sym[sym].sy_atxt=Pd_r[i].addr;
	}
}
/*------------------------------------------------------------------*/
/*			int find_sym(char *name,int flag)						*/
/*																	*/
/*																	*/
/*		 Sucht einen Symboleintrag									*/
/*		Parameter: 	name: Name des Eintrags							*/
/*					flag: soll bei nicht finden abgebrochen werden?	*/
/*		Rckgabe : 	index des Symbols								*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

/* Sucht einen Symboleintrag	*/
int find_sym(char *name,int flag)
{	int i,ret=-1;
	char fehler[100];
	for(i=0;i<Anz_sym;i++)
	{	if(!strcmp(Sym[i].sy_name,name))
		{	ret=i;
			break;
		}
	}
	if(ret<0 && flag)
	{	sprintf(fehler,"[1][%s ist nicht|in PD_LIB.LIB][Abbruch]",name);
		form_alert( 1,fehler);
		exit(0);
	}
	return(ret);
}
/*------------------------------------------------------------------*/
/*			void get_pd(PH *ph,PD_ORI *pd_o)						*/
/*																	*/
/*																	*/
/* 			ldt das original PD.PRG								*/
/*			ffnet das File fr das neue Pd_i.PRG					*/
/*		Parameter: 	ph: da soll der Programmheader rein				*/
/*					pd_o: da sonstige Infos zu PD.PRG				*/
/*		Rckgabe : 	in ph und pd_o									*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/


void get_pd(PH *ph,PD_ORI *pd_o)
{	char dat_n[50]="*.PRG";
	
/* Original PD suchen	*/


	if(!F_in)			/* noch nicht in get_addr geladen	*/
	{	if(*File_n)		/* aber bereits ein Name gesetzt	*/
			F_in=fopen(File_n,"rb");
		else
		 	get_akt_path(File_n);
	}
	while(!F_in)
	{	strcpy(strrchr(File_n,'\\')+1,"*.PRG");
		if(!easy_fsel(File_n,dat_n,"PD aussuchen2"))
			exit(0);
		build_filename(File_n,File_n,dat_n);
		
		F_in=fopen(File_n,"rb");
	}
/* File fr neues PD ffnen	*/
	if(Opt_flags.monitore==2)
		build_filename(File_n,File_n,"pd_2.prg");
	else
		build_filename(File_n,File_n,"pd_1.prg");
	F_out=fopen(File_n,"wb");
	if(!F_in || !F_out)
	{	form_alert( 2,"[1][Das angegebene File kann nicht|geffnet werden][Abbruch]");
		exit(0);
	}
/* laden und analysieren	*/
	if(!pd_o->tot_len)
	{	pd_o->tot_len=lof(F_in)-0x1c;
		fseek(F_in,0,SEEK_SET);
		fread(ph,sizeof(PH),1,F_in);		/* Programmheader von PD.PRG laden */
		if((pd_o->text=malloc(pd_o->tot_len))==NULL)
		{	form_alert( 2,"[1][Nicht genug Speicher][Abbruch]");
			exit(0);
		}
		fread(pd_o->text,1,pd_o->tot_len,F_in);				/* PD.PRG laden	*/
	}
	if(strcmp(Version_txt,(char *)&pd_o->text[Pd_a[VERS_PTR].addr]))
	{	form_alert(2,"[1][Dies ist eine mir fremde PD-Version! Falls| es sich nicht um einen Fehler handelt| Bitte PD_ADDR.DAT lschen und Programm neu starten][Bis dann]");
		exit(0);
	}
}
/*------------------------------------------------------------------*/
/*			int init(void)											*/
/*																	*/
/*																	*/
/*		 ffnet die Workstation u..								*/
/*		Parameter: keine											*/
/*		Rckgabe : VDI handle										*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

int init(void)
{  	int handle;
	int int_in[11]= {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2};
	int int_out[57];
	int dummy;
	/* Programm anmelden */
	appl_init();
	handle=graf_handle(&dummy,&dummy,&dummy,&dummy);
  	v_opnvwk(int_in,&handle,int_out);

	return(handle);
}
/*------------------------------------------------------------------*/
/*			int get_addr(PH *ph,PD_ORI *pd_o)						*/
/*																	*/
/*																	*/
/* 		Dise Routine versucht, die fr den Patch ntigen Adressen	*/
/*		aus einer beliebigen PD Version zu ermitteln. 				*/
/*		Parameter: 	Infos zu PD										*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/



void get_addr(PH *ph,PD_ORI *pd_o)
{	char dat_n[50]="";
	memset(Flag,0,ANZ_ROUT);
	if(*File_n)
		F_in=fopen(File_n,"rb");
	if(!F_in)
	 	get_akt_path(File_n);
	while(!F_in)
	{	strcpy(strrchr(File_n,'\\')+1,"*.PRG");
		if(!easy_fsel(File_n,dat_n,"PD aussuchen"))
			exit(0);
		build_filename(File_n,File_n,dat_n);
		
		F_in=fopen(File_n,"rb");
	}
	if(!F_in )
	{	form_alert( 2,"[1][Das angegebene File kann nicht|geffnet werden][Abbruch]");
		exit(0);
	}
	pd_o->tot_len=lof(F_in)-0x1c;
	fseek(F_in,0,SEEK_SET);
	fread(ph,sizeof(PH),1,F_in);		/* Programmheader von PD.PRG laden */
	if((pd_o->text=malloc(pd_o->tot_len))==NULL)
	{	form_alert( 2,"[1][Nicht genug Speicher][Abbruch]");
		exit(0);
	}
	fread(pd_o->text,1,pd_o->tot_len,F_in);				/* PD.PRG laden	*/
	set_namen();	
	suche_rout1(ph->ph_tlen/2l,(UWORD *)pd_o->text);
	suche_dat_bss((UWORD *)pd_o->text,ph);
	suche_rout2(ph->ph_tlen/2l,(UWORD *)pd_o->text);
}
/*------------------------------------------------------------------*/
/*			void suche_rout1(long anz_word,unsigned int p_txt[],N_ROUT)	*/
/*																	*/
/*																	*/
/* 		Hier werden Routinen Anhand, zumindest bei mir, eindeutiger	*/
/*		Sequenzen gesucht											*/
/*	Die Komentare haben folgende Bedeutung:							*/
/*		name	offs:	Inhalt										*/
/*		offs ist also der Offset vom Anfang der Routine name, und 	*/
/*		dort steht Inhalt											*/
/*		Parameter: Programmcode und seine Lnge in Worten			*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/


void suche_rout1(long anz_word,unsigned int p_txt[])
{	long i,sys_rout;
	char fehler[200];
	int cpu_clrs=0;
	Pd_r[CPU_CLR].addr=1l+2l*(ULONG)CPU_CLR;
	Flag[CPU_CLR]++;
	
	for(i=0;i<anz_word;i++)
	{	switch(p_txt[i])
		{	case 0x14:			/*draw_menu	2a:	0014 322a 0016 302a	*/
				if(p_txt[i+1]==0x322a && p_txt[i+2]==0x0016 && p_txt[i+3]==0x302a)
				{	Pd_r[DRAW_MENU].addr=i*2l-0x2al;
					Flag[DRAW_MENU]++;
				}
				break;
			case 0x027c:		/* Bomben	8:	027c dfff 4ef9	*/
				if(p_txt[i+1]==0xdfff && p_txt[i+2]==0x4ef9)
				{	Pd_r[BOMBEN].addr=i*2l-8l;
					Flag[BOMBEN]++;
				}
				
				break;
			case 0x223c:
				switch(p_txt[i+1])
				{	case 0x4D00:			/* graf_handel	4:	223C 4D00 0500	*/
						if(p_txt[i+2]==0x0500)
						{	Pd_r[GRAF_HANDLE].addr=i*2l-4l;
							Flag[GRAF_HANDLE]++;
						}
						break;
					case 0x3401:		/* form_alert	c: 223c 3401 0101*/
						if(p_txt[i+2]==0x0101)
						{	Pd_r[FORM_ALERT].addr=i*2l-0xcl;
							Flag[FORM_ALERT]++;
						}
						break;
				}
				break;
			case 0x3f3c:	/* move.w	#,-(sp)	*/
				switch(p_txt[i+1])
				{	case 0x0002:	/* Physbase		2:	3F3C 0002 4E4E	*/
						if(p_txt[i+2]==0x4E4E)
						{	Pd_r[PHYSBASE].addr=i*2l-0x2l;
							Flag[PHYSBASE]++;
						}
						break;
					case 0x0003:	/* Logbase		2:	3F3C 0003 4E4E		*/
						if(p_txt[i+2]==0x4E4E)
						{	Pd_r[LOGBASE].addr=i*2l-0x2l;
							Flag[LOGBASE]++;
						}
						break;
					case 0x0005:	
						if(p_txt[i+2]==0x4E4E)	/* Setscreen	8:	3F3C 0005 4E4E	*/
						{	Pd_r[SETSCREEN].addr=i*2l-0x8l;
							Flag[SETSCREEN]++;
						}
						else	/*set_my_exc 10: 001a 3f03 3f3c 0005	*/
						{	if(p_txt[i-1]==0x3f03 && p_txt[i-2]==0x001a )
							{	Pd_r[SETMYEXC].addr=i*2l-0x14l;
								Flag[SETMYEXC]++;
							}
						}
						break;
					case 0x0021:	/* Set_Gd_trm	1e: 2f08 3f3c 0021*/
						if(p_txt[i-1]==0x2f08)
						{	Pd_r[SETGDT].addr=i*2l-0x20l;
							Flag[SETGDT]++;
						}
						else		/*Res_Gd_trm	8: 3f3c 0021*/
						{	Pd_r[RESGDT].addr=i*2l-0x8l;
							Flag[RESGDT]++;
						}
						break;
					case 0x0026:		/* _fpuinit	4: ffcc 3f3c 0026 4e4e	*/
						if(p_txt[i-1]==0xffcc && p_txt[i+2]==0x4e4e)
						{	Pd_r[FPUINIT].addr=i*2l-0x6l;
							Flag[FPUINIT]++;
						}
					case 0x0044:	/* Mxalloc		6:	3F3C 0044 4E41	*/
						if(p_txt[i+2]==0x4E41)
						{	Pd_r[MXALLOC].addr=i*2l-0x6l;
							Flag[MXALLOC]++;
						}
						break;
					case 0x0048:	/* Malloc		0: 4852 2f00 3F3C 0048	*/
						if(p_txt[i-2]==0x4852)
						{	Pd_r[MALLOC].addr=i*2l-0x4l;
							Flag[MALLOC]++;
						}
						break;
					case 0x0049:	
						switch(p_txt[i-1])
						{	case 0x4850:	/* Mfree		2: 4850 3F3C 0049	*/
								Pd_r[MFREE].addr=i*2l-0x4l;
								Flag[MFREE]++;
								break;
							case 0x2F0B:	/* mfree_a_sp	e: 2F0B 3F3C 0049	*/
								Pd_r[MFREEAS].addr=i*2l-0x10l;
								Flag[MFREEAS]++;
								break;
						}
						break;
					case 0x004A:	/* Mshrink		6: 3F00 3F3C 004A	*/
						if(p_txt[i-1]==0x3F00)
						{	Pd_r[MSHRINK].addr=i*2l-0x8l;
							Flag[MSHRINK]++;
						}
						break;
				}
				break;
			case 0x4afc:			/* ILLEGAL	*/
				switch(p_txt[i+1])
				{	case 0x2648:	/* memcpyx		0: 48e7 0818 4afc 2648*/
						if(p_txt[i-1]==0x0818 && p_txt[i-2]==0x48e7)
						{	Pd_r[MEMCPYX].addr=i*2l-0x04l;
							Flag[MEMCPYX]++;
						}
						break;
					case 0x23f8:	/* set_hcop_vb  : 6: 4afc 23f8 0502 */
						if(p_txt[i+2]==0x502)
						{	Pd_r[SETHCV].addr=i*2l-0x06l;
							Flag[SETHCV]++;
						}
						break;
					case 0x21f9:	/* res_hcop_vb		0: 4afc 21f9 ; 10: 0502*/
						if(p_txt[i+8]==0x502)
						{	Pd_r[RESHCV].addr=i*2l-0x0l;
							Flag[RESHCV]++;
						}
						break;
				}
				break;
			case 0x4e41:			/* Trap 1 (Gemdos)	*/
				switch(p_txt[i-1])
				{
					case 0x3e:			/*Fclose	c:	003e 4e41 584f 245f	*/
						if(p_txt[i+1]==0x584f && p_txt[i+2]==0x245f)
						{	Pd_r[FCLOSE].addr=i*2l-0xel;
							Flag[FCLOSE]++;
						}
						break;
					case 0x3f:			/*Fread	c:	003f 4e41 4fef 000c 245f	*/
						if(p_txt[i+1]==0x4fef && p_txt[i+2]==0x000c && p_txt[i+3]==0x245f)
						{	Pd_r[FREAD].addr=i*2l-0xel;
							Flag[FREAD]++;
						}
						break;
					case 0x47:			/*Dgetpath	8:	0047 4e41 504f 245f	*/
						if(p_txt[i+1]==0x504f && p_txt[i+2]==0x245f)
						{	Pd_r[DGETPATH].addr=i*2l-0xAl;
							Flag[DGETPATH]++;
						}
						break;
				}
				break;
			case 0x4e4d:			/* Trap 13 (Bios)	*/
				switch(p_txt[i-1])
				{	case 1:			/* Bconstat	4:	3f3c 0001 4e4d	*/
						if(p_txt[i-2]==0x3f3c)
						{	Pd_r[BCONSTAT].addr=i*2l-8l;
							Flag[BCONSTAT]++;
						}
						break;
					case 2:			/* Bconin oder Bconin_4s	*/
						if(p_txt[i-2]==0x3f3c)
						{	if(p_txt[i-3]==0x3f00)	/* Bconin	2:	3f00 3f3c 0002 4e4d	*/
							{	Pd_r[BCONIN].addr=i*2l-8l;
								Flag[BCONIN]++;
							}
							else					/* Bconin_4s	2:	0002 3f3c 0002 4e4d	*/
							{	Pd_r[BCONIN4S].addr=i*2l-8l;
								Flag[BCONIN4S]++;
							}
						}
						break;
					case 5:			/* Setexc	4:	3ebc 0005 4e4d	*/
						if(p_txt[i-2]==0x3ebc)
						{	Pd_r[SETEXC].addr=i*2l-8l;
							Flag[SETEXC]++;
						}
						break;
					case 0xA:			/* Drvmap	2:	3f3c 000A 4e4d	*/
						if(p_txt[i-2]==0x3f3c)
						{	Pd_r[DRVMAP].addr=i*2l-6l;
							Flag[DRVMAP]++;
						}
						break;
					
				}
				break;
			case 0x4e68:	
				if(p_txt[i+1]==0x082f)
				{	switch(p_txt[i+6])
					{	case 0x000A:	/* Gemdos2	16: 4e68 082f und 22: 000A	*/
							Pd_r[GEMDOS2].addr=i*2l-0x16l;
							Flag[GEMDOS2]++;
							break;
						case 0x000C:	/* Gemdos2a	16: 4e68 082f und 22: 000C	*/
							Pd_r[GEMDOS2A].addr=i*2l-0x16l;
							Flag[GEMDOS2A]++;
							break;
					}
				}
				break;
			case 0x4e7a:		/* clear_cash	0: 4e7a 0002 807c 0808 4e7b 0002	*/
				if(p_txt[i+1]==0x2 && p_txt[i+2]==0x807c && p_txt[i+3]==0x808 &&
									  p_txt[i+4]==0x4e7b && p_txt[i+5]==0x2)
				{	Pd_r[CPU_CLR+1+cpu_clrs].addr=i*2l;
					Flag[CPU_CLR+1+cpu_clrs++]++;
				}
			case 0x6606:		/* Etv_term		16:	6606 40e7*/
				if(p_txt[i+1]==0x40e7)
				{	Pd_r[ETVTRM].addr=i*2l-0x16l;
					Flag[ETVTRM]++;
				}
				break;
			case 0x701B:		/* esc_h_etc	8: 701B		10: 7048*/
				if( p_txt[i+4]==0x7048)
				{	Pd_r[ESC_H_ETC].addr=i*2l-0x8l;
					Flag[ESC_H_ETC]++;
				}
				break;
			case 0x7073:		/* v_opnvwk		36:	7073 4E42*/
				if(p_txt[i+1]==0x4E42)
				{	Pd_r[V_OPNVWK].addr=i*2l-0x36l;
					Flag[V_OPNVWK]++;
				}
				break;
			case 0x7265:		/* v_clsvwk		0:	7265 7400*/
				if(p_txt[i+1]==0x7400)
				{	Pd_r[V_CLSVWK].addr=i*2l;
					Flag[V_CLSVWK]++;
				}
				break;
			case 0x7266:		/* vq_extnd		16:	7266 7401*/
				if(p_txt[i+1]==0x7401)
				{	Pd_r[VQ_EXTND].addr=i*2l-0x16l;
					Flag[VQ_EXTND]++;
				}
				break;
			case 0x726D:		/* vro_cpyfm	16:	726D 243C 0004	*/
				if(p_txt[i+1]==0x243C && p_txt[i+2]==0x0004)
				{	Pd_r[VRO_CPYFM].addr=i*2l-0x16l;
					Flag[VRO_CPYFM]++;
				}
				break;
			case 0x727A:		/* v_show_c		6:	727A 7401*/
				if(p_txt[i+1]==0x7401)
				{	Pd_r[V_SHOW_C].addr=i*2l-6l;
					Flag[V_SHOW_C]++;
				}
				break;
			case 0x727B:		/* v_hide_c	=	0:	727B 7400*/
				if(p_txt[i+1]==0x7400)
				{	Pd_r[V_HIDE_C].addr=i*2l;
					Flag[V_HIDE_C]++;
				}
				break;
			case 0x727C:		/* vq_mouse	4:	727C 7400*/
				if(p_txt[i+1]==0x7400)
				{	Pd_r[VQ_MOUSE].addr=i*2l-4l;
					Flag[VQ_MOUSE]++;
				}
				break;
			case 0xB03C:		/* chk_path	4:	B03C 0050*/
				if(p_txt[i+1]==0x0050)
				{	Pd_r[CHK_PATH].addr=i*2l-0x12l;
					Flag[CHK_PATH]++;
				}
				break;
			case 0xC0BC:		/* Malloc_high	12:	C0BC FFFF FFFC*/
				if(p_txt[i+1]==0xFFFF && p_txt[i+2]==0xFFFC)
				{	Pd_r[MALLOC_H].addr=i*2l-12l;
					Flag[MALLOC_H]++;
				}
				break;
			case 'PD':			/* 'PDeb' bzw 'PDEB' sollte im Original nicht vorkommen*/
				if(p_txt[i+1]=='eb' ||p_txt[i+1]=='EB' )
				{	if(form_alert(1,"[2][Knnte es sein da es sich hier bereits|um eine gepatchte Version handelt?][ Ja | Nein ]")==1)
					{	form_alert(1,"[3][Dann ist ein Patch unmglich][Schade]");
						exit(0);
					}
				}
				break;
			
		}
	}
	
	if(cpu_clrs!=ANZ_CPU_CLR)
	{	sprintf(fehler,"[3][Das Lschen des CPU-Cashes|wurde %i * statt %i * gefunden][Abbruch]",cpu_clrs,ANZ_CPU_CLR);
		form_alert(1,fehler);
		exit(0);
	}

	/* Die folgenden Routinen knnen direkt aus der Adresse von set_my_exc
		abgeleitet werden	*/

	sys_rout=Pd_r[SETMYEXC].addr+0x2al;	/* ab hier steht Sprungtabelle fr setexc	*/
	i=sys_rout/2l;
	Pd_r[BOMB4].addr	=sys_rout+(long)*((int *)&p_txt[i+ 4l]);
	Pd_r[NOPRIV].addr	=sys_rout+(long)*((int *)&p_txt[i+ 8l]);
	Pd_r[TRACE].addr	=sys_rout+(long)*((int *)&p_txt[i+ 9l]);
	Pd_r[LINEA].addr	=sys_rout+(long)*((int *)&p_txt[i+10l]);
	Pd_r[AESVDI].addr	=sys_rout+(long)*((int *)&p_txt[i+34l]);
	Pd_r[TOS1].addr	=sys_rout+(long)*((int *)&p_txt[i+46l])+6l;	/* direkt hinter XBIOS	*/
	Flag[BOMB4]=Flag[NOPRIV]=Flag[TRACE]=Flag[LINEA]=Flag[AESVDI]=Flag[TOS1]=1;

}
/*------------------------------------------------------------------*/
/*			void suche_dat_bss(unsigned int p_txt[],PH *ph)			*/
/*																	*/
/*																	*/
/* 		Hier werden die Adressen zu Daten gesucht (DATA +BSS) 		*/
/*		DATA dadurch, das der Inhalt gesucht wird,					*/
/*		BSS durch Zugriffe in bereits bekannten Routinen			*/
/*		Parameter: Programmcode und -header							*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/


void suche_dat_bss(unsigned int p_txt[],PH *ph)
{	long i,j;
	int k;
	char fehler[200];
	char *p_txtc,*p_datc;
	p_txtc=(char *)p_txt;
	p_datc=&p_txtc[ph->ph_tlen];
	/* Datas suchen	*/
	for(i=0;i<ph->ph_dlen;i++)
	{	switch(p_datc[i])
		{	case '%':	/* Formatstring fr Programm info*/
				if(!strcmp(&p_datc[i],"%06lX"))
				{
					Pd_a[TXT_AT_F].addr=ph->ph_tlen+i;
					Flag_a[TXT_AT_F]++;
				}
				break;
			case 'P':
				if(!strcmp(&p_datc[i],"PD.CFG"))
				{
					Pd_a[PD_CFG].addr=ph->ph_tlen+i;
					Flag_a[PD_CFG]++;
				}
				if(!strcmp(&p_datc[i],"P:"))
				{
					Pd_a[LW_P].addr=ph->ph_tlen+i;
					Flag_a[LW_P]++;
				}
				break;
			case -1:	/* Object, da Text at: enthlt */
				if((long)(p_datc+i)%2==0)  /* nur gerade Adressen */
				{
					if(*((long*)&p_datc[i])==-1l)
					{	j=*((long*)&p_datc[i+10]);
						if(j>=ph->ph_tlen && (j-ph->ph_tlen)<ph->ph_dlen)
						{	if(!strcmp(&p_txtc[j],"Text at:"))
							{
								Pd_a[TXT_AT].addr=i+22l+ph->ph_tlen;
								Flag_a[TXT_AT]++;
							}
						}
					}
				}
				break;
			case 'U':		
				if(!strcmp(&p_datc[i],"User program not yet terminated|Reset program anyway?"))
				{
					Pd_a[RES_ANY].addr=ph->ph_tlen+i;
					Flag_a[RES_ANY]++;
				}
				break;
			case 'V':		
				if(!strncmp(&p_datc[i],"Vers",4))
				{	Pd_a[VERS_PTR].addr=ph->ph_tlen+i;
					strcpy(Version_txt,&p_datc[i]);
					Flag_a[VERS_PTR]++;
				}
				break;

		}
	}
/* Prfen ob alle Adressen genau 1* gefunden wurden	*/
	for(k=0;k<ANZ_ADDR;k++)
	{	if(Flag_a[k]!=1)
		{	sprintf(fehler,"[3][Adresse Pd_a(%d)|wurde %d x gefunden][Abbruch|Weiter]",k,(int)Flag_a[k]);
			if(form_alert(1,fehler)==1)
				exit(0);
		}
	}	
	
	/* BSS bestimmen	*/
	Pd_d[B_2AD06].addr=*((long *)&p_txtc[Pd_r[SETGDT].addr+0x14l]);
	Pd_d[PRG_ASP].addr=*((long *)&p_txtc[Pd_r[SETGDT].addr+0x4l]);
	Pd_d[USEOGEM].addr=*((long *)&p_txtc[Pd_r[SETGDT].addr+0xal]);
	Pd_d[ANZBOMB].addr=*((long *)&p_txtc[Pd_r[BOMB4].addr+0xcl]);
	Pd_d[GDSEMA1].addr=*((long *)&p_txtc[Pd_r[BOMBEN].addr+0x2l]);
	Pd_d[ORSR2].addr=*((long *)&p_txtc[Pd_r[TOS1].addr-0x4l])-176;
	Pd_d[ALTHLP].addr=*((long *)&p_txtc[Pd_r[SETHCV].addr+0x2l]);
	Pd_d[FPUMODE].addr=*((long *)&p_txtc[Pd_r[FPUINIT].addr-0x22l]);
	if(*((int *)&p_txtc[Pd_r[MALLOC_H].addr+0xAEl])==0x26b9)
		Pd_d[MEM_L1].addr=*((long *)&p_txtc[Pd_r[MALLOC_H].addr+0xB0l]);
	else
	{	form_alert(1,"[3][Kann Mem_l1 nicht bestimmen][Schade]");
		exit(0);
	}
	return;
}
/*------------------------------------------------------------------*/
/*			void suche_rout2(long anz_word,unsigned int p_txt[])	*/
/*																	*/
/*																	*/
/*		wie suche_rout1, allerdings werden bereits vorher bestimmte	*/
/*		Adressen bentigt											*/
/*		Parameter: Programmcode und seine Lnge in Worten			*/
/*		Rckgabe : 	keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/


void suche_rout2(long anz_word,unsigned int p_txt[])
{	long i;
	int j;
	char fehler[200];
	for(i=0;i<anz_word;i++)
	{	switch(p_txt[i])
		{	case 0x33FC:		/*BombXY	0:	33FC XY Anz_Bomb*/
				if( *(long *)&p_txt[i+2] ==Pd_d[ANZBOMB].addr )
				{	switch(p_txt[i+1])
					{	case 0x1c:	/* Bomb28	*/
							if(p_txt[i-1]==0x4e75)
							{	Pd_r[BOMB28].addr=i*2l;
								Flag[BOMB28]++;
							}
							break;
						case 0x21:	/* Bomb33	*/
							Pd_r[BOMB33].addr=i*2l;
							Flag[BOMB33]++;
							break;
					}
				}
				break;
			case 0x41f9:		/*reset		12: 41f9 reset_any*/
				if( *(long *)&p_txt[i+1] ==Pd_a[RES_ANY].addr )
				{	Pd_r[RESET].addr=i*2l-0x12l;
					Flag[RESET]++;
					Pd_r[RESET_A].addr=Pd_r[RESET].addr+10l;
					Flag[RESET_A]++;
					Pd_d[B_23E58].addr=*(long *)&p_txt[i-7l];
				}
				break;
			case 0x47f9:	/* lea nach a3	*/
				if( *(long *)&p_txt[i+1] ==Pd_d[ORSR2].addr &&p_txt[i+4]==0x2f1b)	/*res_my_exc	4:	47f9 or_srout2 7602 2f1b*/
				{	Pd_r[RESMYEXC].addr=i*2l-4;
					Flag[RESMYEXC]++;
				}
				else
				{	if( *(long *)&p_txt[i+1] ==Pd_d[MEM_L1].addr)	/*mfree_l1	8:	47f9 Mem_l1*/
					{	Pd_r[MFREEL1].addr=i*2l-8;
						Flag[MFREEL1]++;
					}
				}
				break;
			case 0x4eb9:		/* jsr*/
				if(p_txt[i+3]==0x4e75)		/* rts	*/
				{	if( *(long *)&p_txt[i+1] ==Pd_r[V_SHOW_C].addr)	/*Show_curs	10:	4eb9 v_show_c.l 4e75 */
					{	Pd_r[SHOW_CURS].addr=i*2l-0x10l;
						Flag[SHOW_CURS]++;
					}
					if( *(long *)&p_txt[i+1] ==Pd_r[V_HIDE_C].addr)	/*Hide_curs	16:	4eb9 v_hide_c.l 4e75 */
					{	Pd_r[HIDE_CURS].addr=i*2l-0x16l;
						Flag[HIDE_CURS]++;
					}
				}
				else
				{	if((*(long *)&p_txt[i+1] ==Pd_r[FREAD].addr)&&p_txt[i-2] == 0x96)
					{	Pd_r[VIEW_F].addr=i*2l+2;
						Flag[VIEW_F]++;
					}
				}
				break;
		}
	}
/* Prfen ob alle Routinen genau 1* gefunden wurden	*/
	for(j=0;j<ANZ_ROUT;j++)
	{	if(Flag[j]!=1)
		{	sprintf(fehler,"[3][Routine %i: %s|wurde %i * gefunden][Abbruch|Weiter]",j,Pd_r[j].name,Flag[j]);
			if(form_alert(1,fehler)==1)
				exit(0);
		}
	}	
}
/*------------------------------------------------------------------*/
/*			void set_namen(void)									*/
/*																	*/
/* 	Setzen der Namen in den Feldern Pd_r, Pd_d						*/
/*																	*/
/*		Parameter: keine											*/
/*		Rckgabe : keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void set_namen(void)
{	strcpy(Pd_r[DRAW_MENU].name,"draw_menu");
	strcpy(Pd_r[SHOW_CURS].name,"show_curs");
	strcpy(Pd_r[HIDE_CURS].name,"hide_curs");
	strcpy(Pd_r[RESET].name,"prg_reset");
	strcpy(Pd_r[RESET_A].name,"prg_reset_a");
	strcpy(Pd_r[MALLOC_H].name,"malloc_high");
	strcpy(Pd_r[MFREEL1].name,"mfree_l1");
	strcpy(Pd_r[BOMB28].name,"Bomb28");
	strcpy(Pd_r[BOMB33].name,"Bomb33");
	strcpy(Pd_r[BOMBEN].name,"Bomben");
	strcpy(Pd_r[RESMYEXC].name,"res_my_exc");
	strcpy(Pd_r[SETMYEXC].name,"set_my_exc");
	strcpy(Pd_r[BOMB4].name,"Bomb4");
	strcpy(Pd_r[TRACE].name,"Trace");
	strcpy(Pd_r[NOPRIV].name,"NoPriv");
	strcpy(Pd_r[LINEA].name,"LineA");
	strcpy(Pd_r[AESVDI].name,"AesVdi");
	strcpy(Pd_r[TOS1].name,"Tos1");
	strcpy(Pd_r[MEMCPYX].name,"memcpyx");
	strcpy(Pd_r[ESC_H_ETC].name,"esc_h_etc");
	strcpy(Pd_r[RESGDT].name,"Res_Gd_trm");
	strcpy(Pd_r[MFREEAS].name,"mfree_a_sp");
	strcpy(Pd_r[GEMDOS2].name,"Gemdos2");
	strcpy(Pd_r[SETGDT].name,"Set_Gd_trm");
	strcpy(Pd_r[SETHCV].name,"set_hcop_vb");
	strcpy(Pd_r[RESHCV].name,"res_hcop_vb");
	strcpy(Pd_r[GEMDOS2A].name,"Gemdos2a");
	strcpy(Pd_r[ETVTRM].name,"Etv_term");
	strcpy(Pd_r[FCLOSE].name,"Fclose");
	strcpy(Pd_r[FREAD].name,"Fread");
	strcpy(Pd_r[SETEXC].name,"Setexc");
	strcpy(Pd_r[MXALLOC].name,"Mxalloc");
	strcpy(Pd_r[MSHRINK].name,"Mshrink");
	strcpy(Pd_r[MFREE].name,"Mfree");
	strcpy(Pd_r[MALLOC].name,"Malloc");
	strcpy(Pd_r[SETSCREEN].name,"Setscreen");
	strcpy(Pd_r[PHYSBASE].name,"Physbase");
	strcpy(Pd_r[LOGBASE].name,"Logbase");
	strcpy(Pd_r[GRAF_HANDLE].name,"graf_handle");
	strcpy(Pd_r[FORM_ALERT].name,"form_alert");
	strcpy(Pd_r[V_SHOW_C].name,"v_show_c");
	strcpy(Pd_r[V_OPNVWK].name,"v_opnvwk");
	strcpy(Pd_r[V_HIDE_C].name,"v_hide_c");
	strcpy(Pd_r[V_CLSVWK].name,"v_clsvwk");
	strcpy(Pd_r[VRO_CPYFM].name,"vro_cpyfm");
	strcpy(Pd_r[VQ_MOUSE].name,"vq_mouse");
	strcpy(Pd_r[CHK_PATH].name,"chk_path");
	strcpy(Pd_r[DGETPATH].name,"Dgetpath");
	strcpy(Pd_r[VQ_EXTND].name,"vq_extnd");
	strcpy(Pd_r[VIEW_F].name,"view_file_fread");
	strcpy(Pd_r[FPUINIT].name,"fpu_init");
	strcpy(Pd_r[CPU_CLR].name,"cpu_clr Marke:");
	strcpy(Pd_r[CPU_CLR1].name,"cpu_clr 1.mal:");
	strcpy(Pd_r[CPU_CLR2].name,"cpu_clr 2.mal:");
	strcpy(Pd_r[CPU_CLR3].name,"cpu_clr 3.mal:");
	strcpy(Pd_r[CPU_CLR4].name,"cpu_clr 4.mal:");
	strcpy(Pd_r[CPU_CLR5].name,"cpu_clr 5.mal:");
	strcpy(Pd_r[CPU_CLR6].name,"cpu_clr 6.mal:");
	strcpy(Pd_r[CPU_CLR7].name,"cpu_clr 7.mal:");
	strcpy(Pd_r[CPU_CLR8].name,"cpu_clr 8.mal:");
	strcpy(Pd_r[CPU_CLR9].name,"cpu_clr 9.mal:");
	strcpy(Pd_r[CPU_CLR10].name,"cpu_clr 10.mal:");
	strcpy(Pd_r[CPU_CLR11].name,"cpu_clr 11.mal:");
	strcpy(Pd_r[CPU_CLR12].name,"cpu_clr 12.mal:");
	strcpy(Pd_r[BCONIN].name,"Bconin");
	strcpy(Pd_r[BCONIN4S].name,"Bconin_4s");
	strcpy(Pd_r[BCONSTAT].name,"Bconstat");
	strcpy(Pd_r[DRVMAP].name,"Drvmap");

	
	strcpy(Pd_d[B_23E58].name,"b_23E58");
	strcpy(Pd_d[MEM_L1].name,"Mem_l1");
	strcpy(Pd_d[B_2AD06].name,"B_2AD06");
	strcpy(Pd_d[ANZBOMB].name,"AnzBomben");
	strcpy(Pd_d[GDSEMA1].name,"GD_sema1");
	strcpy(Pd_d[ORSR2].name,"or_srout2");
	strcpy(Pd_d[ALTHLP].name,"Alt_Hlp");
	strcpy(Pd_d[PRG_ASP].name,"Prg_a_sp");
/*	strcpy(Pd_d[PTRTERM].name,"Ptr_term");	*/
	strcpy(Pd_d[USEOGEM].name,"use_or_gem");
	strcpy(Pd_d[FPUMODE].name,"_fpumode");
	
	strcpy(Pd_a[PD_CFG].name,"Pd_cfg");
	strcpy(Pd_a[LW_P].name,"Lw_P");
	strcpy(Pd_a[VERS_PTR].name,"PD Version Pointer");
	strcpy(Pd_a[TXT_AT].name,"'Text at:'");
	strcpy(Pd_a[TXT_AT_F].name,"'Text at:'- Formatstring");
	strcpy(Pd_a[RES_ANY].name,"Reset anyway");

}

/*------------------------------------------------------------------*/
/*			int read_addr(void)										*/
/*																	*/
/*																	*/
/* 		Statt mit get_addr ermittelt knnen die Adressen auch aus 	*/
/*		einem DAT File gelesen werden								*/
/*		Parameter: keine											*/
/*		Rckgabe : erfolgreich?										*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

int read_addr(void)
{	FILE *file;
	char f_vers[100];
	int anz,ret=1;
	if((file=fopen("PD_ADDR.DAT","rb"))==NULL)
		return(0); 	/* dann halt nicht	*/
	fgets(f_vers,99,file);
	*strchr(f_vers,'\n')='\0';
	if(strcmp(f_vers,Prgvers))
		ret=0;
	else
	{	fread(&anz,sizeof(int),1,file);
		if(anz==ANZ_ROUT)
			fread(Pd_r,sizeof(PD_ROUT),ANZ_ROUT,file);
		else
			ret=0;
	}
	if(ret)
	{	fread(&anz,sizeof(int),1,file);
		if(anz==ANZ_DAT)
			fread(Pd_d,sizeof(PD_ROUT),ANZ_DAT,file);
		else
			ret=0;
	}
	if(ret)
	{	fread(&anz,sizeof(int),1,file);
		if(anz==ANZ_ADDR)
			fread(Pd_a,sizeof(PD_ROUT),ANZ_ADDR,file);
		else
			ret=0;
	}
	if(ret)
	{	if(fgets(File_n,(int)sizeof(File_n)-1,file))
		{
			*strchr(File_n,'\n')='\0';
			if(fgets(Version_txt,(int)sizeof(Version_txt)-1,file))
				*strchr(Version_txt,'\n')='\0';
			else
				ret=0;
		}
		else
			ret=0;
	}
	fclose(file);
	return(ret);
}
/*------------------------------------------------------------------*/
/*			void save_addr(void)									*/
/*																	*/
/*																	*/
/* gefundene Adressen fr nchstesmal merken						*/
/*		Parameter: keine											*/
/*		Rckgabe : keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void save_addr(void)
{	FILE *file;
	int anz=ANZ_ROUT;
	if((file=fopen("PD_ADDR.DAT","wb"))==NULL)
		return; 	/* dann halt nicht	*/
	fputs(Prgvers,file);
	fputc('\n',file);
	fwrite(&anz,sizeof(int),1,file);
	fwrite(Pd_r,sizeof(PD_ROUT),ANZ_ROUT,file);
	anz=ANZ_DAT;
	fwrite(&anz,sizeof(int),1,file);
	fwrite(Pd_d,sizeof(PD_ROUT),ANZ_DAT,file);
	anz=ANZ_ADDR;
	fwrite(&anz,sizeof(int),1,file);
	fwrite(Pd_a,sizeof(PD_ROUT),ANZ_ADDR,file);
	fputs(File_n,file);
	fputc('\n',file);
	fputs(Version_txt,file);
	fputc('\n',file);
	fclose(file);
}
/*------------------------------------------------------------------*/
/*			void save_addr_txt(void)								*/
/*																	*/
/*																	*/
/* Nur zu Kontrollzwecken noch eine Klartextversion	von save_addr	*/
/*		Parameter: keine											*/
/*		Rckgabe : keine											*/
/*																	*/
/*		(c) Dimitri Junker											*/
/*																	*/
/*------------------------------------------------------------------*/

void save_addr_txt(void)
{	FILE *file;
	int anz=ANZ_ROUT,i;
	if((file=fopen("PD_ADDR.TXT","w"))==NULL)
		return; 	/* dann halt nicht	*/
	fprintf(file,"Dieses File ist nur zu Kontrollzwecken.\n");
	fprintf(file,"Es ist einfacher zu lesen als das DAT File.\n");
	fprintf(file,"Die z.B. bei cpu_clr angegebene Adresse ist nur eine Pseudoaddresse!\n\n");
	
	fprintf(file,"Version des Patchprogramms: %s\n\n",Prgvers);
	fprintf(file,"\nAnzahl Routinen: %i\n\n",anz);
	for(i=0;i<ANZ_ROUT;i++)
		fprintf(file,"Pd_r[%2i] = {%-25s ; 0x%-9lX} \n",i,Pd_r[i].name,Pd_r[i].addr);
	anz=ANZ_DAT;
	fprintf(file,"\nAnzahl Daten: %i\n\n",anz);
	for(i=0;i<ANZ_DAT;i++)
		fprintf(file,"Pd_d[%2i] = {%-25s ; 0x%-9lX} \n",i,Pd_d[i].name,Pd_d[i].addr);

	anz=ANZ_ADDR;
	fprintf(file,"\nAnzahl sonstige Addressen: %i\n\n",anz);
	for(i=0;i<ANZ_ADDR;i++)
		fprintf(file,"Pd_a[%2i] = {%-25s ; 0x%-9lX} \n",i,Pd_a[i].name,Pd_a[i].addr);

	fprintf(file,"\nPD Version: %s\n",Version_txt);
	fclose(file);
}
