/*			 PD_LIB.S	V 1.08
		(c) 1997,99 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen	*/

/* Dies sind die Assembler-Funktionen, die in PD eingefgt werden knnen*/

import	Bomb4,X_pd,Etv_term,get_act_pd_0,get_cpu_0
import	or_srout2,tst_sysva_x,Alt_Hlp,Bomb28
import	AnzBomben,Tos1,res_sysv_x,Setexc
import	LineA,AesVdi,NoPriv,Trace,Bomben,Gemdos2,Gemdos2a
import	B_2AD06,Prg_a_sp,use_or_gem,GD_sema1,Bomb33
export	vdi_2,Supexec_0,Ptr_Gemd,Ptr_term,xSys_Rout,clear_cpu_0
export	set_my_exc_x,tst_id_0,PGemdos,PGemdos1,set_gd_trm_x
export	res_my_exc_x,set_etvc_x,My_id,Ptr_scrd,Ptr_vb,set_hcop_vb_x
export set_mpc_comp_0,Crawcin_0,Cconis_0,emuDate_0

;------------------------------------------------------------------
;		Routinen fr den 1 und 2 Monitorbetrieb
;------------------------------------------------------------------

;------------------------------------------------------------------
;			tst_id_0
;			
;	berprft ob das aktuelle Programm PD ist (BASPAG), wenn
; 	ja kehrt es einfach zurck, wenn nicht ndert es die 
;	Rcksprungadresse auf dem Stack so, da es in die Originalroutine
;	(lt. XBRA) springt
; 	Um XBRA zu finden wird einfach die Rcksprungadresse verwendet
; 	daraus folgt, da unmittelbar vor dem 
;	bsr.w tst_id_0 
; 	die XBRA Struktur stehen mu. Auerdem ist das '.w' wichtig, da sonst
; 	ggf ein bsr.s verwendet wrde, und somit auch eine falsche Adresse
;	ermittelt wrde
;			
;		Parameter: 		keine
;		Rckgabe : 		keine
;
;		(c) Dimitri Junker
;
;------------------------------------------------------------------


.MODULE tst_id_0
			movem.l		d0-d3/a0-a1,-(sp)
			move.l		X_pd,d3
			jsr			get_act_pd_0
			cmp.l		a0,d3
			bne			to_orig
			movem.l		(sp)+,d0-d3/a0-a1
			rts
to_orig:	movea.l		24(sp),a0			;die eigentliche Rcksprungadresse
			move.l		-8(a0),24(sp)		;da sollte die Originalroutine aus XBRA stehen
			movem.l		(sp)+,d0-d3/a0-a1	
			rts								;springt in die Originalroutine


.ENDMOD
;------------------------------------------------------------------
;			long  Supexec_o( long (*func)( ));
;			
;		ein ganz normales Supexec, wird aber in PD bisher
;		so nicht verwendet	
;		Parameter: 		A0: auszufhrende Funktion
;		Rckgabe : 		D0: Rckgabe der Funktion	
;
;
;------------------------------------------------------------------

MODULE Supexec_0
			move.l		a2,-(sp)
			move.l		a0,-(sp)
			move.w		#$26,-(SP)
			trap		#14		;Supexec
			addq.w		#6,SP
			movea.l		(sp)+,a2
			rts
.ENDMOD
;------------------------------------------------------------------
;			long  Crawcin_0( void);
;			
;		ein ganz normales Crawcin
;		Parameter: 		keine
;		Rckgabe : 		die Taste + Scancode	
;
;
;------------------------------------------------------------------

MODULE Crawcin_0
			move.w		#7,-(sp)
			trap		#1
			addq.l		#2,sp
			rts
.ENDMOD
;------------------------------------------------------------------
;			WORD  Cconis_0( void);
;			
;		ein ganz normales Cconis
;		Parameter: 		keine
;		Rckgabe : 		die Taste + Scancode	
;
;
;------------------------------------------------------------------

MODULE Cconis_0
			move.w		#$B,-(sp)
			trap		#1
			addq.l		#2,sp
			rts
.ENDMOD

;------------------------------------------------------------------
;			long  set_mpc_comp_0( int anaus);
;			
;		Schaltet bei MagicPC>6.10 den Compiler ein oder aus
;		Parameter: 		D0: 1:an
;							0:aus
;							-1:Nachfragen
;		Rckgabe : 		D0: alter Status (0 oder 1)	
;							bei MagicPC 6.10 vom 7.10.99 immer -1
;
;------------------------------------------------------------------

MODULE set_mpc_comp_0
			move    	d0,d1          * 0,1 oder -1 nach d1
			ext.l		d1
			moveq    	#1,d0          * 1 nach d0
			dc.w     	$43bf,$0045    * mec1, Funktion $45
			rts
.ENDMOD
;------------------------------------------------------------------
;		long emuDate_0()
;			
;		gibt das Versionsdatum von MagicPC zurck
;		Parameter: 		keiner
;		Rckgabe : 		D0: Datum, in der Form: 0xjjjjmmtt	
;
;
;------------------------------------------------------------------


.MODULE emuDate_0
		moveq		#2,d0
		dc.w		$43bf,$0002
		rts
		
.ENDMOD

;------------------------------------------------------------------
;		Routinen fr den 2 Monitorbetrieb (_2)
;------------------------------------------------------------------

;------------------------------------------------------------------
;			void vdi_2( VDIPB *vdipb );
;			
;		ein ganz normales vdi, wird aber in PD bisher
;		so nicht verwendet	
;			
;		Parameter: 		A0: VDI-Parameterblock
;		Rckgabe : 		keine
;
;
;------------------------------------------------------------------

.MODULE vdi_2
		PEA			(A2)
		MOVEQ		#$73,D0
		MOVE.L		A0,D1
		TRAP		#$2				 ; VDI/AES
		MOVEA.L		(SP)+,A2
		RTS
.ENDMOD

;------------------------------------------------------------------
;		Routinen zur XBRA-Implementation ( _x)
;------------------------------------------------------------------

;------------------------------------------------------------------
;			set_my_exc_x
;			
; 		Diese Routine ist im Wesentlichen eine Kopie der
;		Originalroutine (set_my_exc). Zustzlich haben hier alle 
;		mit Setexc eingefgten Routinen einen XBRA-Header, und es 
;		wird am Anfang jeder Routine geprft, ob der Aufrufer
;		PD ist oder nicht. Falls nicht wird in die Routine
;		gesprungen, die im XBRA Header steht.
;			
;		Parameter: 	keine	
;		Rckgabe : 	keine
;
;
;------------------------------------------------------------------


.MODULE set_my_exc_x
			movem.l		D3/A2-A4,-(SP)		;setzt Vektoren 0- $40 auf
			lea			xSys_Rout(PC),A3	;eigene Routinen
			clr.w		D3
xset_mex_nx:move.w		(A3)+,D0
			beq.s		xno_setex
			lea			xSys_Rout(PC,D0.w),a4
			move.l		a4,-(SP)
			move.w		D3,-(SP)
			move.w		#5,-(SP)
			trap		#13		;Setexc
			addq.w		#8,SP
			move.l		d0,-4(a4)			;Originalroutine in XBRA schreiben
xno_setex:	addq.w		#1,D3
			cmp.w		#$40,D3
			bcs.s		xset_mex_nx
			movem.l		(SP)+,D3/A2-A4
			rts
xSys_Rout:	dc.w		0,0	
			dc.w		Bomb2_x-xSys_Rout		; 2:	2 Bomben			Bomb2
			dc.w		Bomb3_x-xSys_Rout		; 3:	3 Bomben			Bomb3
			dc.w		Bomb4_x-xSys_Rout		; 4:	4 Bomben			Bomb4
			dc.w		Bomb5_x-xSys_Rout		; 5:	5 Bomben			Bomb5
			dc.w		Bomb6_x-xSys_Rout		; 6: 	CHK Befehl			Bomb6
			dc.w		Bomb7_x-xSys_Rout		; 7:	TRAPV				Bomb7
			dc.w		NoPriv_x-xSys_Rout		; 8: 	Privilegverletzung	NoPriv
			dc.w		Trace_x-xSys_Rout		; 9:	Trace				Trace
			dc.w		LineA_x-xSys_Rout		;10:	Line-A-Vektor		LineA
			dc.w		0,0
			dc.w		Bomb13_x-xSys_Rout		;13:	Coproz Priv Verletz. Bomb13
			dc.w		Bomb14_x-xSys_Rout		;14:	Format Error		Bomb14
			dc.w		0,0,0,0,0,0,0,0,0
			dc.w		Bomb24_x-xSys_Rout		;24:	Spurious Interrupt	Bomb24
			dc.w		0,0,0,0,0,0,0,0
			dc.w		Gemdos1_x-xSys_Rout		;33:	Trap 1: Gemdos		Gemdos1
			dc.w		AesVdi_x-xSys_Rout		;34:	Trap 2: AES + VDI	AesVdi
			dc.w		0,0,0,0,0,0,0,0,0,0
			dc.w		Bios_x-xSys_Rout			;45:	Trap 13: BIOS		Bios
			dc.w		XBios_x-xSys_Rout		;46:	Trap 14: XBIOS		Xbios
			dc.w		0
			dc.w		Bomb48_x-xSys_Rout		;48:	FPCP Branch,...		Bomb48
			dc.w		Bomb49_x-xSys_Rout		;49:	FPCP Inexact Res.	Bomb49
			dc.w		Bomb50_x-xSys_Rout		;50:	FPCP /0				Bomb50
			dc.w		Bomb51_x-xSys_Rout		;51:	FPCP underflow		Bomb51
			dc.w		Bomb52_x-xSys_Rout		;52:	FPCP Operand Error	Bomb52
			dc.w		Bomb53_x-xSys_Rout		;53:	FPCP Overflow		Bomb53
			dc.w		Bomb54_x-xSys_Rout		;54:	FPCP NAN			Bomb54
			dc.w		0,0,0,0,0,0,0,0,0

			dc.b 		'XBRA'
My_id:		dc.b		'PDeb'
			dc.l		0
Bomb2_x:	bsr.w		tst_id_0
			move.w		#2,AnzBomben			;	2 Bomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb3_x:	bsr.w		tst_id_0
			move.w		#3,AnzBomben			;	3 Bomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb4_x:	bsr.w		tst_id_0
			jmp			Bomb4


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb5_x:	bsr.w		tst_id_0
			move.w		#5,AnzBomben			;	5 Bomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb6_x:	bsr.w		tst_id_0
			move.w		#6,AnzBomben			;	6 Bomben: CHK
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb7_x:	bsr.w		tst_id_0
			move.w		#7,AnzBomben			;	7 Bomben: TRAPV
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
NoPriv_x:	bsr.w		tst_id_0				; 	Privilegverletzung
			jmp			NoPriv

			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Trace_x:	bsr.w		tst_id_0
			jmp			Trace

			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb13_x:	bsr.w		tst_id_0
			move.w		#13,AnzBomben
			jmp			Bomben

			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb14_x:	bsr.w		tst_id_0
			move.w		#14,AnzBomben
			jmp			Bomben

			move.w		#$18,AnzBomben
			jmp			Bomben
			move.w		#$20,AnzBomben
			jmp			Bomben
			move.w		#$23,AnzBomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb24_x:	bsr.w		tst_id_0
			move.w		#24,AnzBomben
			jmp			Bomben

			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb48_x:	bsr.w		tst_id_0
			move.w		#48,AnzBomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb49_x:	bsr.w		tst_id_0
			move.w		#49,AnzBomben
			jmp			Bomben

			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb50_x:	bsr.w		tst_id_0
			move.w		#50,AnzBomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb51_x:	bsr.w		tst_id_0
			move.w		#51,AnzBomben
			jmp			Bomben

			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb52_x:	bsr.w		tst_id_0
			move.w		#52,AnzBomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb53_x:	bsr.w		tst_id_0
			move.w		#53,AnzBomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
Bomb54_x:	bsr.w		tst_id_0
			move.w		#54,AnzBomben
			jmp			Bomben


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
LineA_x:	bsr.w		tst_id_0
			jmp			LineA


			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_gem1:	dc.l		0
Gemdos1_x:	bsr.w		tst_id_0
			move.l		Ptr_gem1(pc),-(SP)
			jmp			Tos1


			dc.b 		'XBRA'
			dc.b		'PDeb'
			dc.l		0
AesVdi_x:	bsr.w		tst_id_0
			jmp			AesVdi


			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_bios1:	dc.l		0
Bios_x:		bsr.w		tst_id_0
			move.l		Ptr_bios1(pc),-(SP)
			jmp			Tos1

			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_xbios:	dc.l		0
XBios_x:	bsr.w		tst_id_0
cont_xb:	move.l		Ptr_xbios(pc),-(SP)
			jmp			Tos1
.ENDMOD

;------------------------------------------------------------------
;			res_my_exc_x
;			
;			
;	Diese Routine restauriert die mit set_my_exc_x verbogenen
;	Pointer. Im Original PD wurden dazu XBRA-inkompatibel am Anfang
;	die Vektoren 0-$40 gesichert und hier wieder zurckgesetzt.
; 	Hier wird jetzt nach XBRA-Mnier gelscht. Fr den Notfall,
;	schlielich ist es ein Debugger, wird auf alte Manier
;	restauriert (s. res_sysv_x in PD_LIB.C )
;		Parameter: 		keine
;		Rckgabe : 		keine
;
;		(c) Dimitri Junker
;
;------------------------------------------------------------------


.MODULE res_my_exc_x
			movem.l		D3/A2-A4,-(SP)		;setzt Vektoren 2- $40 zurck
			lea			xSys_Rout(PC),A3	;wird benutzt um zu wissen welche verbogen waren
			adda.w		#4,a3				;Vektoren 0,1 berspringen
			lea			or_srout2,A4		;mit getexc ermittelte Werte
			moveq		#2,D3				;Vektor 2
xrs_mex_nx:	tst.w		(A3)+				;wenn da 0 steht hat PD ihn nicht gendert
			beq.s		xno_rsetex			
			move.w		d3,d0				;Vektornummer
			movea.l		(a4),a0				;mit getexc ermittelte Originalroutine
			bsr			res_sysv_x
			
xno_rsetex:	addq.w		#1,D3				;nchster Vektor
			adda.w		#4,a4				;nchste Originalroutine
			cmp.w		#$40,D3
			bcs.s		xrs_mex_nx
			movem.l		(SP)+,D3/A2-A4
			rts
.ENDMOD
;------------------------------------------------------------------
;			set_gd_trm_x
;			
;			
; 		Dies ist i.W. die Originalroutine, aber mit XBRA aufgewertet
;		Es werden die Systemvektoren Gemdos trap und etv_term verbogen
;
;		Parameter: 		keine
;		Rckgabe : 		keine
;
;
;------------------------------------------------------------------

.MODULE	set_gd_trm_x
			move.l		A2,-(SP)		; Setzt Gemdos trap auf Gemdos2
			clr.l		Prg_a_sp
			sf			use_or_gem
			lea			Gemdos2_x(pc),A0
			move.l		a0,-(sp)
			move.w		#$21,-(SP)
			move.w		#5,-(SP)
			trap		#13		;Setexc	Gemdos
			addq.w		#8,SP
			lea			Ptr_Gemd(PC),a2	
			move.l		D0,(a2)	;alte Adresse in XBRA eintragen

			pea			Etv_trm_x(PC)	
			move.w		#$102,-(SP)
			move.w		#5,-(SP)
			trap		#13		;Setexc	etv_term
			addq.w		#8,SP
			lea			Ptr_term(PC),a2	
			move.l		D0,(a2)	;alte Adresse in XBRA eintragen
			movea.l		(SP)+,A2
;			bsr			clear_cpu_0
			rts

;------------------------------------------------------------------
;			Gemdos2_x
;			
;			Gemdos-Traphandler		
;		Im Gegensatz zum Original mit XBRA.
;		bei fopen,fclose,fcreate wird noch zustzlich gespeichert
;			welche Filehandle geffnet sind. Da vorher die Basepage
;			un die Semaphoren geprft wurden, ist sichergestellt,
;			da nur die vom zu debuggenden PRG gespeichert werden
;		bei Mxalloc wird wie bereits bei Malloc der Speicher in
;			der verketteten Liste Prg_a_sp gespeichert, um ihn
;			bei einem Programm-Reset freizugeben. Es sei denn,
;			im Modusbit ist Bit 14(No-Free-Modus) gesetzt.
;			
;		Parameter: 		s. Gemdos Trap
;		Rckgabe : 		je nach Funktion
;
;
;------------------------------------------------------------------

			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_Gemd:	dc.l		0
Gemdos2_x:	bsr.w		tst_id_0
			tst.b		GD_sema1
			beq			gd2_o_gem
			tst.b		use_or_gem
			bne			gd2_o_gem
			move.l		A0,-(SP)
			move		usp,A0
			btst		#5,4(SP)
			beq.s		Gemdos2b
			lea			X_pd,a0
			movea.w		12(a0),a0	; Framelength	6 oder 8
			adda.w		#4,a0		; 10 oder 12
			adda.l		sp,a0
Gemdos2b:	move.w		(A0)+,D0
			cmp.w		#$4C,D0
			bhi			gd2_n
			add.w		D0,D0
			move.w		gd2_st(PC,D0.w),D0
			jmp 		gd2_st(PC,D0.w)
;gemdos Sprungtabelle
gd2_st:		dc.w		gd2_pt0-gd2_st								;0 = Pterm0
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;8
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st

			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;10
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;18
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st

			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;20
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;28
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st

			dc.w		gd2_n-gd2_st									;30
			dc.w		gd2_pt-gd2_st								;31=Ptermres
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;38
			dc.w		gd2_fo-gd2_st										;3C=Fcreate
			dc.w		gd2_fo-gd2_st										;3D=Fopen
			dc.w		gd2_fc-gd2_st										;3E=Fclose
			dc.w		gd2_n-gd2_st

			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st	;40
			dc.w		gd2_mxa-gd2_st								;44=Mxalloc
			dc.w		gd2_n-gd2_st,gd2_n-gd2_st,gd2_n-gd2_st
			dc.w		gd2_ma-gd2_st								;48=Malloc
			dc.w		gd2_mf-gd2_st								;49=Mfree
			dc.w		gd2_ms-gd2_st								;4a=Mshrink
			dc.w		gd2_px-gd2_st								;4B=Pexec
			dc.w		gd2_pt-gd2_st								;4C=Pterm

gd2_n:		movea.l		(SP)+,A0
gd2_o_gem:	move.l		Ptr_Gemd(pc),-(sp)
			rts
gd2_pt0:	moveq		#0,D0
gd2_pt_r:	movea.l		(SP)+,A0
			subq.l		#2,2(SP)
			bra			Bomb33
gd2_pt:		move.w		(A0),D0
			bra	.s		gd2_pt_r
gd2_px:		move.w		(A0),D0
			cmp.w		#3,D0
			beq.s		gd2_n
			cmp.w		#5,D0
			beq.s		gd2_n
			st			use_or_gem
			move.l		10(A0),-(SP)
			move.l		6(A0),-(SP)
			move.l		2(A0),-(SP)
			move.w		D0,-(SP)
			move.w		#$4B,-(SP)
			trap		#1		;Pexec
			lea			$10(SP),SP
			sf			use_or_gem
			movea.l		(SP)+,A0
			rte
gd2_ma:		move.l		(A0),D0
			cmp.l		#-1,D0
			beq.s		gd2_ma_t
			addq.l		#8,D0
			move.l		D1,-(SP)
			st			use_or_gem
			move.l		D0,-(SP)
			move.w		#$48,-(SP)
			trap		#1		;Malloc
			addq.w		#2,SP
			move.l		(SP)+,D1
			sf			use_or_gem
			tst.l		D0
			ble	.s		gd2_ma_e
			movea.l		D0,A0
			move.l		Prg_a_sp,(A0)
			move.l		D1,4(A0)
			move.l		A0,Prg_a_sp
			addq.l		#8,D0
gd2_ma_e:	move.l		(SP)+,D1
			movea.l		(SP)+,A0
			rte
gd2_ma_t:	st			use_or_gem
			move.l		D0,-(SP)
			move.w		#$48,-(SP)
			trap		#1		;Malloc
			addq.w		#6,SP
			sf			use_or_gem
			subq.l		#8,D0
			bcs.s		gd2_ma_t0
			movea.l		(SP)+,A0
			rte
gd2_ma_t0:	moveq		#0,D0
			movea.l		(SP)+,A0
			rte
; wie gd2_ma aber fr Mxalloc

gd2_mxa:	move.w		4(A0),D0			; mode
			and.w		#$4000,d0			; Bit 14(No-Free-Modus) gesetzt?
			bne			gd2_n				; dann 'normales' Mxalloc
			move.l		(A0),D0				; amount
			cmp.l		#-1,D0				; Freien Speicher erfragen?
			beq.s		gd2_mxa_t
			addq.l		#8,D0
			move.l		D1,-(SP)
			st			use_or_gem
			move.w		4(a0),-(sp)
			move.l		D0,-(SP)
			move.w		#$44,-(SP)
			trap		#1		;Mxalloc
			addq.w		#2,SP
			move.l		(SP)+,D1
			addq.w		#2,SP
			sf			use_or_gem
			tst.l		D0
			ble	.s		gd2_mxa_e
			movea.l		D0,A0
			move.l		Prg_a_sp,(A0)
			move.l		D1,4(A0)
			move.l		A0,Prg_a_sp
			addq.l		#8,D0
gd2_mxa_e:	move.l		(SP)+,D1
			movea.l		(SP)+,A0
			rte
gd2_mxa_t:	st			use_or_gem
			move.w		4(a0),-(sp)
			move.l		d0,-(SP)
			move.w		#$44,-(SP)
			trap		#1		;Mxalloc
			addq.w		#8,SP
			sf			use_or_gem
			subq.l		#8,D0
			bcs.s		gd2_mxa_t0
			movea.l		(SP)+,A0
			rte
gd2_mxa_t0:	moveq		#0,D0
			movea.l		(SP)+,A0
			rte
gd2_mf:		movem.l		D1/A1,-(SP)
			move.l		(A0),D0
			subq.l		#8,D0
			lea			Prg_a_sp,A1
			bra	.s		gd2_mf_1
gd2_mf_n:	cmpa.l		D0,A1
			beq.s		gd2_mf_e
gd2_mf_1:	movea.l		A1,A0
			movea.l		(A0),A1
			move.l		A1,D1
			bne	.s		gd2_mf_n
			movem.l		(SP)+,D1/A1
			bra			gd2_n
gd2_mf_e:	move.l		(A1),(A0)
			st			use_or_gem
			move.l		D0,-(SP)
			move.w		#$49,-(SP)
			trap		#1		;Mfree
			addq.w		#6,SP
			sf			use_or_gem
			movem.l		(SP)+,D1/A1
			movea.l		(SP)+,A0
			rte
gd2_ms:		movem.l		D1-D2/A1,-(SP)
			move.l		2(A0),D0
			subq.l		#8,D0
			move.l		6(A0),D1
			addq.l		#8,D1
			lea			Prg_a_sp,A1
			bra	.s		gd2_ms_1
gd2_ms_n:	cmpa.l		D0,A1
			beq.s		gd2_ms_e
gd2_ms_1:	movea.l		A1,A0
			movea.l		(A0),A1
			move.l		A1,D2
			bne	.s		gd2_ms_n
			movem.l		(SP)+,D1-D2/A1
			bra			gd2_n
gd2_ms_e:	st			use_or_gem
			move.l		D1,4(A1)
			move.l		D1,-(SP)
			move.l		D0,-(SP)
			clr.w		-(SP)
			move.w		#$4A,-(SP)
			trap		#1		;Mshrink
			lea			12(SP),SP
			sf			use_or_gem
			movem.l		(SP)+,D1-D2/A1
			movea.l		(SP)+,A0
			rte

/* nach Fopen und Fcreate Flag fr neues Handle setzen	*/
gd2_fo:		st			use_or_gem
			move.w		4(a0),-(sp)			;mode
			move.l		(a0),-(sp)			;fname
			move.w		-2(a0),-(sp)		;#60 oder #61
			trap		#1					;Fcreate oder Fopen
			addq.l		#8,sp
			sf			use_or_gem
			tst.l		d0
			bmi			gd2_fo_n			
			tst.w		d0
			bmi			gd2_fo_n
			cmp.l		#64,d0
			bpl			gd2_fo_n
			movem.l		d0-d1,-(sp)
			lea			X_pd,a0
			adda.w		#8,a0
			cmp.w		#32,d0
			bmi			gd2_fo_0
			sub			#32,d0
			suba.w		#4,a0
gd2_fo_0:	move.l		(a0),d1
			bset		d0,d1
			move.l		d1,(a0)
			movem.l		(sp)+,d0-d1
gd2_fo_n:	movea.l		(SP)+,A0
			rte

/* bei Fclose Flag lschen	*/
gd2_fc:		st			use_or_gem
			move.w		(a0),-(sp)			;Handle
			move.w		-2(a0),-(sp)		;#62
			trap		#1					;Fclose
			addq.l		#4,sp
			sf			use_or_gem
			movem.l		d0-d1,-(sp)
			tst.w		d0
			bmi			gd2_fc_n			;erfolgreich?

			clr.l		d0
			move.w		2(a0),d0
			bmi			gd2_fc_n
			cmp.w		#64,d0
			bpl			gd2_fc_n
			lea			X_pd,a0
			adda.w		#8,a0
			cmp.w		#32,d0
			bmi			gd2_fc_0
			sub			#32,d0
			suba.w		#4,a0
gd2_fc_0:	move.l		(a0),d1
			bclr		d0,d1
			move.l		d1,(a0)
gd2_fc_n:	movem.l		(sp)+,d0-d1
			movea.l		(SP)+,A0
			rte


			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_term:	dc.l		0
Etv_trm_x:	bsr.w		tst_id_0
;			move.l		or_srout33,-(SP)	was sollte das?
			jmp			Etv_term

			

.ENDMOD

;------------------------------------------------------------------
;			void (*set_etvc_x( int number, void (*exchdlr)() )) ();
;			ersetzt Setexc
;			
; Setexc wird nur 2* in PD aufgerufen, alle anderen Routinen fhren
; selber den TRAP durch. In beiden Fllen wird etv_critic verbogen
; bzw beim 2. mal wiederhergestellt. Sicherheitshalber (andere PD
; Version) prfe ich ob es wirklich etv_critic ist, wenn ja wird
; entweder verbogen oder restauriert, entschieden wird dies anhand
; des Pointers in der XBRA Struktur
; Auerdem wird hier (nur beim zurcksetzen) geprft, ob noch Vektoren
; in PD-Speicherblcke zeigen, diese werden dann auch zurckgesetzt. 
; Im Gegensatz zu Programm Reset gibt PD am Programmende diesen Speicher
; nicht frei, sondern berlt dies dem Startup Code des PureC. Deshalb
; werden hier weder mfree_l1 noch mfree_a_sp aufgerufen, die dies ja
; auch erledigen wrden.
;
;		Parameter: 	s. Setexc	
;
;		(c) Dimitri Junker
;
;------------------------------------------------------------------

.MODULE	set_etvc_x
			move.l		A2,-(SP)		; Setzt etv_critic trap
			cmp.w		#$101,d0		; sicherheithalber
			bne			se_err			; mir unbekanntes Setexc
			lea.l		Ptr_etvc(PC),a2	
			tst.l		(a2)			; set oder reset?
			bne			res_etvc
			lea			etv_c_x(pc),A0
			move.l		a0,-(sp)
			move.w		d0,-(SP)
			move.w		#5,-(SP)
			trap		#13				;Setexc	etv_critic
			addq.w		#8,SP
			lea			Ptr_etvc(PC),a2
			move.l		D0,(a2)			; alte Adresse in XBRA eintragen
;			bsr			clear_cpu_0
			movea.l		D0,A0			; Rckgabe
se_ok:		movea.l		(SP)+,A2
			rts
res_etvc:	bsr			res_sysv_x
			lea.l		Ptr_etvc(PC),a2	
			clr.l		(a2)			; man wei nie
;			bsr			clear_cpu_0
			bsr			tst_sysva_x
			bra 		se_ok
se_err:		bsr			Setexc
			bra			se_ok

			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_etvc:	dc.l		0

etv_c_x:	moveq		#-1,D0
			rts
.ENDMOD

;------------------------------------------------------------------
;			set_hcop_vb_x
;			
;			
; 		Dies ist i.W. die Originalroutine, aber mit XBRA aufgewertet
;		Es werden die Systemvektoren Scrdmp und 
;		Autovektor-Interrupt, Level 4 (Vertical Blanc)  verbogen
;
;		Parameter: 		keine
;		Rckgabe : 		keine
;
;
;------------------------------------------------------------------

.MODULE set_hcop_vb_x
			sf			Alt_Hlp
			illegal
			move.l		$502.w,Ptr_scrd		;scr_dump
			lea			scr_dump_x(PC),A0
			move.l		A0,$502.w			;scr_dump
			move.l		$70.w,Ptr_vb		;autov_int4	
			lea			v_blk_x(PC),A0
			move.l		A0,$70.w			;autov_int4
			move		(SP)+,sr
;			bsr			clear_cpu_0
			rts

;bei scr_dump_x kein tst_id_0, da man sonnst zufllig <ALT><HELP>
;drcken mu, wenn PD dran ist

			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_scrd:	dc.l		0
scr_dump_x:	st			Alt_Hlp
			rts
			move.l		Ptr_scrd,-(SP)
			rts



			dc.b 		'XBRA'
			dc.b		'PDeb'
Ptr_vb:		dc.l		0
v_blk_x:	bsr.w		tst_id_0
			tst.b		Alt_Hlp
			beq.s		vbl_n
			btst		#5,(SP)
			bne	.s		vbl_n
			tst.b		GD_sema1
			beq.s		vbl_n
			sf			Alt_Hlp
			tst.w		B_2AD06
			beq.s		vbl_1
			clr.w		-(SP)
vbl_1:		pea			Bomb28(PC)
			move		sr,-(SP)
vbl_n:		move.l		Ptr_vb,-(SP)
			rts
.ENDMOD

;------------------------------------------------------------------
;			clear_cpu_0(void)
;			
;			
; 		Lscht ggf. vorhandene CPU-Cashes. Dies ist immer dann
;		ntig, wenn 'selbsmodifizierender Code' benutzt wird.
;		Also z.B. beim setzen/lschen von Breakpoints, schreiben
;		in XBRA-Strukturen,... 
;		Hier wird zwar 68040-Code verwendet, da aber der _CPU-Cookie
;		ausgewertet wird sollte er nur auf 68040-Cpu's ausgefhrt werden
;		Das macht also keine Probleme.
;
;		Parameter: 		keine
;		Rckgabe : 		keine
;
;
;------------------------------------------------------------------
MC68040
.MODULE clear_cpu_0
			move.l		d0,-(sp)
            move.w 		sr,-(sp)
			ori 		#$700,sr 		;Interrupts sperren
			
			jsr			get_cpu_0
			
			cmpi.w 		#40,d0 			;68040?
			blt.s 		cl_cpu030
			cpusha 		bc 				;beide Caches lschen
			bra.s 		cl_cpu_exit
			
cl_cpu030:	cmp.w 		#20,d0 			;68020 oder 68030?
			blt.s 		cl_cpu_exit
			
			movec 		cacr,d0
			or.w 		#$808,d0		;Daten- und Instruktionscache lschen
			movec 		d0,cacr
			
cl_cpu_exit:move.w 		(sp)+,sr 		;Statusregister zurck
			move.l		(sp)+,d0
 			rts
.ENDMOD
MC68000
