/*		START_PD	 V 1.05
		(c) 1997 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen	*/

/* Dieses Programm dient als Starter fr PD. es ist ntig um beim Start
aus PC heraus die Wahl zwischen PD_1.PRG (1-Monitor) und PD_2.PRG (2-Monitore)
zu haben. Auerdem erlaubt es den Start von PD_i per AV_STARTPROG, und
somit falls durch Shell und OS untersttzt den Start als Singeltask 
Da PC als Debugger immer PD.PRG startet mu diese Programm so heien. Falls 
es unter MiNT luft kann auch der MiNT-Starter fr PD aufgerufen werden.
Unter nicht-MiNT Systemen dient der Starter hauptschlich als Vermittler zwischen
PC und den verschiedenen PDs. */

#define NEWTOS

/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */

#include "easyfsel.h"
#include <AES.H>
#include <STRING.H>
#include <STDLIB.H>

/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */

#define PRG_NAME	"PD      "
#define		STASK				1
#define		ZWEIMON				2
#define		INVALID				4
#define		W_MINT				8
#define		MINT_ST				16
#define		AV_PROTOKOLL		(0x4700)
#define		AV_STARTPROG		(0x4722)
#define		VA_PROGSTART        (0x4723)

#define 	INF_FILE			"START_PD.INF"
/* -------------------------------------------------------------------- */
/* 		typedefs														*/
/* -------------------------------------------------------------------- */

typedef struct
{	char *pfad;
	char *cmd;
	char aname[9];
	int  pc_starten;
}PD_INF;
/* -------------------------------------------------------------------- */
/* 		lokale Funktionsprototypen										*/
/* -------------------------------------------------------------------- */

void send_av_stpr(int z_id,int my_id,char *prg_name,char *cmd,int id);
void send_av_prot(int z_id,int my_id,char *prg_name,int flags);
int Mxmask (void);
int start_mit_mint(PD_INF *inf);
PD_INF *get_pd_inf(int argc, const char *argv[],int flags);
int setup(int flags_alt);

/* -------------------------------------------------------------------- */
/*		globale Variablen												*/
/* -------------------------------------------------------------------- */


/* -------------------------------------------------------------------- */
/*		Funktionen														*/
/* -------------------------------------------------------------------- */


int main(int argc, const char *argv[])
{	int flags=INVALID,error=0,my_id=0,buf[8];
	long kb;
	FILE *file;
	PD_INF *pd_inf;
	appl_init();	
	kb=Kbshift(-1);
	if((file=fopen(INF_FILE,"rb"))!=NULL)
	{	fread(&flags,sizeof(flags),1,file);
		fclose(file);
	}
	if (get_cookie('MiNT', NULL))
		flags|=W_MINT;
	if((kb&8l)==8l || (flags&INVALID)!=0)	/* wenn Alternate oder kein INF-File*/
		flags=setup(flags&(~INVALID));
	pd_inf=get_pd_inf(argc,argv,flags);
	if( (flags&(W_MINT|MINT_ST) )==(W_MINT|MINT_ST))
		error=start_mit_mint(pd_inf);
	else
	{	if((flags&STASK)==STASK)
		{	my_id=appl_init();
			send_av_prot(0,my_id,PRG_NAME,0);
			send_av_stpr(0,my_id,pd_inf->pfad,&pd_inf->cmd[1],'PD');
			do
				evnt_mesag(buf);
			while(*buf!=VA_PROGSTART);
			if(pd_inf->pc_starten)
				while(appl_find(pd_inf->aname)>-1);	/* warten bis nicht mehr vorhanden	*/
			appl_exit();
		}
		else
			Pexec(0,pd_inf->pfad,pd_inf->cmd,NULL);		/* hier braucht nicht gewartet zu werden, da Pexec erst zurckkehrt wenn PRG beendet*/
	}
	if(pd_inf->pc_starten)	/* PC wieder starten	*/
		shel_write(1,1,0,&strstr(argv[1],"-X=")[3],"");
	appl_exit();

	return(error);
}

/* Der PD-Pfad kann entweder bergeben werden (-PD=...) oder je nach Flag wird PD_1.PRG
oder PD_2.PRG im aktuellen Pfad genommen.
Im 1. Fall mu ab erhht werden, damit dieser Parameter nicht an PD bergeben wird	*/
PD_INF *get_pd_inf(int argc, const char *argv[],int flags)
{	char *ptr;
	PD_INF *inf;
	int mxmask,ab=1,i;
	if((mxmask=Mxmask())==0)
		inf=Malloc(500);
	else
		inf=Mxalloc(500,mxmask&0x2B);
	if(!inf)
		return(NULL);
	inf->pfad=(char *)&inf[1];
	inf->cmd=&inf->pfad[300];
	if(argc>ab)
	{	if((ptr=strstr(argv[ab],"-PD="))!=NULL)
		{	strcpy(inf->pfad,ptr+4);
			ab++;
		}
	}
	if(ab==1)
	{	get_akt_path(inf->pfad);
		if((flags&ZWEIMON)==ZWEIMON)
		{	build_filename(inf->pfad,inf->pfad,"PD_2.PRG");
			strcpy(inf->aname,"PD_2    ");
		}
		else
		{	build_filename(inf->pfad,inf->pfad,"PD_1.PRG");
			strcpy(inf->aname,"PD_1    ");
		}
	}
/* Und jetzt noch die Komandozeile*/	
	*inf->cmd='\0';
/* Falls PD mit gedrckter Shift-Taste (PC) gestartet wurde, so hat sich PC
	beendet und mu spter wieder gestartet werden, dies geschiet normalerweise
	dadurch, da PD in der Komandozeile ein entsprechender Befehl bergeben
	wird, dies klappt hier aber nicht mehr, deshalb wartet dieses PRG
	darauf, da sich PD beendet und startet dann PC neu	*/
	inf->pc_starten=FALSE;
	if(argc>ab)
	{	if(strstr(argv[ab],"-X="))
		{	ab++;
			inf->pc_starten=TRUE;
		}
	}
	
	for(i=ab;i<argc;i++)
	{	strcat(inf->cmd," ");
		strcat(inf->cmd,argv[i]);
	}
	*inf->cmd=(char)(strlen(inf->cmd)-1);
	
	return(inf);

}
/*	Startet Programm ber AV-Server, falls Shell und OS es untersttzen
	wird es dann im Singeltask gestartet, dazu mu es natrlich entsprechend
	angemeldet sein.	*/
void send_av_stpr(int z_id,int my_id,char *prg_name,char *cmd,int id)
{	int buffer[8]={AV_STARTPROG,0,0};
	if(z_id>-1)
	{	buffer[1]=my_id;
		*((char **)&buffer[3])=prg_name;
		*((char **)&buffer[5])=cmd;
		buffer[7]=id;
		appl_write(z_id,16,buffer);
	}
}			
/*	Anmeldung bei AV-Server	*/
void send_av_prot(int z_id,int my_id,char *prg_name,int flags)
{	int buffer[8]={AV_PROTOKOLL,0,0};
	if(z_id>-1)
	{	buffer[1]=my_id;
		buffer[3]=flags;
		buffer[4]=buffer[5]=0;
		*((char **)&buffer[6])=prg_name;
		appl_write(z_id,16,buffer);
	}
}
/* ermittelt, ob es Mxalloc gibt, und welche Modi diese untersttzt */
int Mxmask (void)
{
    void *svStack;      /* Supervisorstack */
    long sRAM, sRAMg;   /* ST-RAM          */
    long aRAM, aRAMg;   /* Alternate RAM   */

    /*
    // Beispieltabelle moeglicher Werte:
    //           | newfashion  | oldfashion
    // sRAM aRAM | sRAMg aRAMg | sRAMg aRAMg
    //   1    0  |   1     0   |   1     1
    //   0    2  |   0     2   |   2     2
    //   1    2  |   1     2   |   3     3
    */

    svStack = (void *) Super( 0);  /* unterbinde Taskwechsel */

    sRAM  = (long) Mxalloc( -1, 0);
    sRAMg = (long) Mxalloc( -1, 0x40); /* im Fehlerfall Mxalloc( -1, 3) */
    aRAM  = (long) Mxalloc( -1, 1);
    aRAMg = (long) Mxalloc( -1, 0x41); /* im Fehlerfall Mxalloc( -1, 3) */

    Super( svStack);  /* erlaube Taskwechsel */

    if (sRAM == -32)
        return 0x0000;  /* Mxalloc() ist nicht implementiert */

    else if ( ((sRAM + aRAM) == sRAMg) && ((sRAM + aRAM) == aRAMg) )
        return 0x0003;  /* oldfashion Mxalloc() */

    else
        return 0xFFFF;

} 

int start_mit_mint(PD_INF *inf)
{	FILE *file;
	int inv=INVALID,err=0;
	if(exist(INF_FILE))
	{	if((file=fopen(INF_FILE,"r+b"))!=NULL)
			fseek(file,2,SEEK_SET);
	}
	else
	{	if((file=fopen(INF_FILE,"wb"))!=NULL)
			fwrite(&inv,sizeof(inv),1,file);
	}
	if(file)
	{	fputs(inf->pfad,file);
		fclose(file);
	}
	else
		err=-1;
	if(	Pexec(0,"PD_MINT.PRG",inf->cmd,NULL)<0)
		err=-2;
	return(err);

}

int setup(int flags_alt)
{	int flags_neu=~(STASK|ZWEIMON|MINT_ST);
	FILE *file;
	flags_neu&=flags_alt;	/* Alle Bits auer STASK und ZWEIMON kopieren	*/
	if((flags_neu&W_MINT)==0)
	{	flags_neu|=(form_alert((flags_alt&STASK)/STASK+1,"[2][Soll PD im Singeltaskmodus|ausgefhrt werden?][Nein| Ja ]")-1)*STASK;
		flags_neu|=flags_alt&MINT_ST;		/* Alten Wert behalten*/
	}
	else
	{	flags_neu|=flags_alt&STASK;		/* Alten Wert behalten*/
		flags_neu|=(form_alert((flags_alt&STASK)/STASK+1,"[2][Soll PD per MiNT Starter|ausgefhrt werden?][Nein| Ja ]")-1)*MINT_ST;
	}
	flags_neu|=(form_alert((flags_alt&ZWEIMON)/ZWEIMON+1,"[2][Soll PD im Zweimonitormodus|ausgefhrt werden?][Nein| Ja ]")-1)*ZWEIMON;
	if(form_alert(2,"[2][Sollen diese Einstellungen|abgespeichert werden?][Nein| Ja ]")==2)
	{	if((file=fopen(INF_FILE,"wb"))!=NULL)
		{	fwrite(&flags_neu,sizeof(flags_neu),1,file);
			fclose(file);
		}
	}
	return(flags_neu);
}


